-- phpMyAdmin SQL Dump
-- version 4.5.4.1deb2ubuntu2
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Apr 22, 2017 at 06:10 PM
-- Server version: 5.7.17-0ubuntu0.16.04.2
-- PHP Version: 7.0.15-0ubuntu0.16.04.4

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `isicms`
--

-- --------------------------------------------------------

--
-- Table structure for table `isicms_application_errors`
--

CREATE TABLE `isicms_application_errors` (
  `id_error` int(11) NOT NULL,
  `error_date` date NOT NULL,
  `id_user` int(11) DEFAULT NULL,
  `query` text COLLATE utf8_bin NOT NULL,
  `parameters` text COLLATE utf8_bin,
  `error_text` text CHARACTER SET latin1,
  `error_file` varchar(250) COLLATE utf8_bin NOT NULL,
  `error_line` varchar(11) COLLATE utf8_bin NOT NULL,
  `error_stack_trace` text COLLATE utf8_bin NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_banned`
--

CREATE TABLE `isicms_banned` (
  `type` tinytext NOT NULL,
  `value` tinytext NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_custom_emaildefaults`
--

CREATE TABLE `isicms_custom_emaildefaults` (
  `customer` varchar(20) NOT NULL,
  `default_to` varchar(250) NOT NULL,
  `default_cc` varchar(250) NOT NULL,
  `default_bcc` varchar(250) NOT NULL,
  `default_subject` varchar(500) NOT NULL,
  `default_body` varchar(2000) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_download_permissions`
--

CREATE TABLE `isicms_download_permissions` (
  `fileID` int(10) NOT NULL,
  `directory` varchar(50) NOT NULL,
  `filetype` varchar(50) NOT NULL,
  `fileperm` varchar(50) NOT NULL,
  `pkey` varchar(50) NOT NULL,
  `pvalue` varchar(50) NOT NULL,
  `timeline` bigint(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_download_permissions`
--

INSERT INTO `isicms_download_permissions` (`fileID`, `directory`, `filetype`, `fileperm`, `pkey`, `pvalue`, `timeline`) VALUES
(0, 'publics', '', 'public', '', '', NULL),
(0, 'download', '', 'group', 'groupID', '2', NULL);

-- --------------------------------------------------------

--
-- Table structure for table `isicms_groups`
--

CREATE TABLE `isicms_groups` (
  `ID_GROUP` int(11) NOT NULL,
  `membergroup` varchar(100) NOT NULL,
  `grouptype` tinyint(1) NOT NULL DEFAULT '0',
  `it_ITdescr` text NOT NULL,
  `en_GBdescr` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_groups`
--

INSERT INTO `isicms_groups` (`ID_GROUP`, `membergroup`, `grouptype`, `it_ITdescr`, `en_GBdescr`) VALUES
(1, 'Administrator', 1, 'Amministratore di Sistema', 'System Administrator'),
(2, 'Other', 1, 'Altro', 'Other');

-- --------------------------------------------------------

--
-- Table structure for table `isicms_groups_principal`
--

CREATE TABLE `isicms_groups_principal` (
  `ID_GROUP` int(11) NOT NULL,
  `membergroup` varchar(100) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_groups_principal`
--

INSERT INTO `isicms_groups_principal` (`ID_GROUP`, `membergroup`) VALUES
(0, 'Administrator'),
(1, 'ISIcms');

-- --------------------------------------------------------

--
-- Table structure for table `isicms_log_activity`
--

CREATE TABLE `isicms_log_activity` (
  `month` tinyint(4) NOT NULL DEFAULT '0',
  `day` tinyint(4) NOT NULL DEFAULT '0',
  `year` mediumint(9) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL DEFAULT '0',
  `topics` int(11) NOT NULL DEFAULT '0',
  `posts` int(11) NOT NULL DEFAULT '0',
  `registers` int(11) NOT NULL DEFAULT '0',
  `mostOn` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_log_errors`
--

CREATE TABLE `isicms_log_errors` (
  `ID_ERROR` smallint(5) UNSIGNED NOT NULL,
  `ID_MEMBER` mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  `logTime` int(10) UNSIGNED NOT NULL DEFAULT '0',
  `IP` tinytext NOT NULL,
  `url` text NOT NULL,
  `message` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_log_online`
--

CREATE TABLE `isicms_log_online` (
  `identity` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `logTime` bigint(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_log_online`
--

INSERT INTO `isicms_log_online` (`identity`, `logTime`) VALUES
(1, 1492874378);

-- --------------------------------------------------------

--
-- Table structure for table `isicms_log_users`
--

CREATE TABLE `isicms_log_users` (
  `ID_LOG` int(20) UNSIGNED NOT NULL,
  `ID_MEMBER` int(10) NOT NULL DEFAULT '0',
  `date` int(20) NOT NULL DEFAULT '0',
  `ip` varchar(20) NOT NULL,
  `query` text NOT NULL,
  `url` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_membergroups`
--

CREATE TABLE `isicms_membergroups` (
  `ID_MEMBER` int(11) NOT NULL,
  `ID_GROUP` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_membergroups`
--

INSERT INTO `isicms_membergroups` (`ID_MEMBER`, `ID_GROUP`) VALUES
(1, 1);

-- --------------------------------------------------------

--
-- Table structure for table `isicms_members`
--

CREATE TABLE `isicms_members` (
  `ID_MEMBER` int(10) UNSIGNED NOT NULL,
  `memberName` varchar(80) NOT NULL,
  `realName` tinytext,
  `passwd` tinytext NOT NULL,
  `emailAddress` tinytext,
  `dateRegistered` bigint(20) DEFAULT NULL,
  `personalText` tinytext,
  `memberGroup` tinyint(3) DEFAULT NULL,
  `gender` tinytext,
  `birthdate` date NOT NULL DEFAULT '0000-00-00',
  `websiteTitle` tinytext,
  `websiteUrl` tinytext,
  `location` tinytext,
  `ICQ` tinytext,
  `AIM` tinytext,
  `YIM` tinytext,
  `hideEmail` tinyint(4) DEFAULT '1',
  `timeFormat` tinytext,
  `signature` text,
  `posts` int(11) DEFAULT NULL,
  `timeOffset` float DEFAULT NULL,
  `avatar` tinytext,
  `im_ignore_list` text,
  `im_email_notify` tinyint(4) NOT NULL DEFAULT '0',
  `lastLogin` bigint(20) DEFAULT NULL,
  `karmaBad` int(11) NOT NULL DEFAULT '0',
  `karmaGood` int(11) NOT NULL DEFAULT '0',
  `usertitle` tinytext,
  `lngfile` tinytext,
  `notifyAnnouncements` tinyint(4) NOT NULL DEFAULT '1',
  `notifyOnce` tinyint(4) NOT NULL DEFAULT '1',
  `MSN` tinytext,
  `memberIP` tinytext,
  `secretQuestion` tinytext,
  `secretAnswer` tinytext,
  `PHPSESSID` varchar(32) DEFAULT NULL,
  `acceptedLicense` tinyint(1) NOT NULL DEFAULT '0',
  `loginAttempts` int(1) NOT NULL DEFAULT '0',
  `firstLogin` int(1) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_members`
--

INSERT INTO `isicms_members` (`ID_MEMBER`, `memberName`, `realName`, `passwd`, `emailAddress`, `dateRegistered`, `personalText`, `memberGroup`, `gender`, `birthdate`, `websiteTitle`, `websiteUrl`, `location`, `ICQ`, `AIM`, `YIM`, `hideEmail`, `timeFormat`, `signature`, `posts`, `timeOffset`, `avatar`, `im_ignore_list`, `im_email_notify`, `lastLogin`, `karmaBad`, `karmaGood`, `usertitle`, `lngfile`, `notifyAnnouncements`, `notifyOnce`, `MSN`, `memberIP`, `secretQuestion`, `secretAnswer`, `PHPSESSID`, `acceptedLicense`, `loginAttempts`, `firstLogin`) VALUES
(1, 'root', 'Demo1234', 'e378a0084bed3b46fd60da40d6fb7b65', 'admin@isigame.net', 1185528830, '', 0, '', '2007-07-27', '', '', '', '', '', '', 1, '', '', 1, 0, 'blank.gif', NULL, 1, 1492874234, 0, 0, '', 'italian.lng', 1, 1, '', '127.0.0.1', '', '', NULL, 1, 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `isicms_members_passwd`
--

CREATE TABLE `isicms_members_passwd` (
  `ID_MEMBER` int(10) NOT NULL,
  `passwd` varchar(32) NOT NULL,
  `pwdChange` bigint(20) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_reserved_names`
--

CREATE TABLE `isicms_reserved_names` (
  `setting` tinytext NOT NULL,
  `value` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_reserved_names`
--

INSERT INTO `isicms_reserved_names` (`setting`, `value`) VALUES
('word', 'root'),
('word', 'Admin'),
('word', 'Webmaster'),
('matchword', '0'),
('matchcase', '1'),
('matchuser', '1'),
('matchname', '1');

-- --------------------------------------------------------

--
-- Table structure for table `isicms_settings`
--

CREATE TABLE `isicms_settings` (
  `variable` tinytext NOT NULL,
  `value` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_settings`
--

INSERT INTO `isicms_settings` (`variable`, `value`) VALUES
('news', 'ISIgame'),
('viewMode', '0'),
('compactTopicPagesContiguous', '5'),
('compactTopicPagesEnable', '1'),
('userViewOverride', '0'),
('agreement', 'You agree, through your use of this site, that you will not post any material which is lammah, false, defamatory, inaccurate, abusive, hateful, harassing, obscene, sexually oriented, threatening, invasive of a person\\\'s privacy, or otherwise in violation of ANY law. This is not only humorous, but legal actions can be taken against you. You also agree not to post any copyrighted material unless the copyright is owned by you or you have consent from the owner of the copyrighted material. Spam, flooding, advertisements, chain letters, pyramid schemes, and solicitations are also inappropriate to this site.Note that it is impossible for us to confirm the validity of posts on this site. Please remember that we do not actively monitor the posted messages and are not responsible for their content. We do not warrant the accuracy, completeness or usefulness of any information presented. The messages express the views of the author, not necessarily the views of this site. Anyone who feels that a posted message is objectionable is encouraged to notify an administrator of this site immediately. We have the rights to remove objectionable content, within a reasonable time frame, if we determine that removal is necessary. This is a manual process, however, so please realize that we may not be able to remove or edit particular messages immediately. This policy goes for member profile information as well.You remain solely responsible for the content of your messages, and you agree to indemnify and hold harmless this site, and any related websites to this site. We at this site also reserve the right to reveal your identity (or any information we have about you) in the event of a complaint or legal action arising from any information posted by you.You have the ability, as you register, to choose your username. We advise that you keep the name appropriate. With this user account you are about to register, you agree to never give your password out to another member, for your protection and for validity reasons. You also agree to NEVER use another member\\\'s account to post messages or browse this site.After you register and log into this site, you can fill out a detailed profile. It is your responsibility to present clean and accurate information. Any information we deem inaccurate or vulgar will be removed.Please note that with each post, your IP address is recorded, in the event that you need to be banned from this site or your ISP contacted. This will only happen in the event of a major violation of this agreement.Also note that the software places a cookie, a text file containing bits of information (such as your username and password), in your browsers cache. This is ONLY used to keep you logged in/out. The software does not collect or sends any other form of information to your computer.'),
('maxdays', '30'),
('yabbinfo', '1119152950'),
('enableStickyTopics', '1'),
('todayMod', '2'),
('karmaMode', '0'),
('karmaTimeRestrictAdmins', '1'),
('enablePreviousNext', '1'),
('PreviousNext_back', '« previous'),
('PreviousNext_forward', 'next »'),
('pollPostingRestrictions', '2'),
('pollMode', '1'),
('pollEditMode', '1'),
('enableVBStyleLogin', '1'),
('enableCompressedOutput', '1'),
('karmaWaitTime', '1'),
('karmaMinPosts', '0'),
('karmaMemberGroups', 'Administrator'),
('karmaLabel', 'Karma:'),
('karmaSmiteLabel', '[smite]'),
('karmaApplaudLabel', '[applaud]'),
('attachmentSizeLimit', '100'),
('attachmentDirSizeLimit', '50240'),
('attachmentUploadDir', '/var/www/isicms/downloads'),
('attachmentUrl', 'http://isicms.isigame.net/downloads'),
('attachmentExtensions', 'jpg,gif,png'),
('attachmentCheckExtensions', '1'),
('attachmentShowImages', '0'),
('attachmentEnable', '1'),
('attachmentEnableGuest', '0'),
('attachmentMemberGroups', 'admin'),
('disableCaching', '0'),
('enableInlineLinks', '0'),
('enableSP1Info', '1'),
('censorWholeWord', '0'),
('mostOnline', '2'),
('mostDate', '1210588247'),
('notifyAnncmnts_UserDisable', '1'),
('viewNewestFirst', '0'),
('trackStats', '1'),
('hitStats', '0'),
('userLanguage', '1'),
('titlesEnable', '1'),
('topicSummaryPosts', '15'),
('enableUserTopicLocking', '0'),
('enableReportToMod', '1'),
('enableErrorLogging', '1'),
('maxwidth', '0'),
('maxheight', '0'),
('onlineEnable', '0'),
('topbottomEnable', '1'),
('cal_memberscanpost', '0'),
('cal_holidaycolor', '000080'),
('cal_bdaycolor', 'C1E5FF'),
('cal_eventcolor', '078907'),
('cal_todaycolor', '111111'),
('cal_enabled', '1'),
('cal_postgroups', 'admin,global moderator'),
('cal_maxyear', '2017'),
('cal_minyear', '2000'),
('cal_daysaslink', '1'),
('cal_startmonday', '1'),
('cal_defaultboard', ''),
('cal_showeventsonindex', '1'),
('cal_showbdaysonindex', '1'),
('cal_showholidaysonindex', '1'),
('cal_captioncolor', 'FFFFFF'),
('cal_postmembers', ''),
('cal_showweeknum', '1'),
('cal_allowspan', '1'),
('cal_maxspan', '7'),
('smtp_host', '127.0.0.1'),
('smtp_username', ''),
('smtp_password', ''),
('mail_type', 'smtp'),
('timeLoadPageEnable', '0'),
('totalTopics', '1'),
('totalMessages', '1'),
('returnToPost', '1'),
('removeNestedQuotes', '1'),
('simpleSearch', '0'),
('localCookies', '0'),
('enableEmbeddedFlash', '0'),
('latestMember', 'root'),
('latestRealName', 'root'),
('memberCount', '148'),
('vbsmiliesEnable', '1'),
('blockEnable', '0'),
('orderEnable', '0'),
('smileydirEnable', '0'),
('hdetach', '200'),
('wdetach', '290');

-- --------------------------------------------------------

--
-- Table structure for table `isicms_webstats_log`
--

CREATE TABLE `isicms_webstats_log` (
  `id` int(11) NOT NULL,
  `log` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_webstats_log`
--

INSERT INTO `isicms_webstats_log` (`id`, `log`) VALUES
(1, 'brow: Java/1.6.0_24');

-- --------------------------------------------------------

--
-- Table structure for table `isicms_webstats_online`
--

CREATE TABLE `isicms_webstats_online` (
  `session_id` varchar(255) NOT NULL,
  `ip` varchar(15) NOT NULL,
  `url` varchar(100) NOT NULL,
  `time` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `isicms_webstats_pages`
--

CREATE TABLE `isicms_webstats_pages` (
  `visit` int(9) NOT NULL DEFAULT '0',
  `page` varchar(50) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_webstats_pages`
--

INSERT INTO `isicms_webstats_pages` (`visit`, `page`) VALUES
(1, 'index');

-- --------------------------------------------------------

--
-- Table structure for table `isicms_webstats_urls`
--

CREATE TABLE `isicms_webstats_urls` (
  `visit` int(9) NOT NULL DEFAULT '0',
  `url` varchar(100) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `isicms_webstats_urls`
--

INSERT INTO `isicms_webstats_urls` (`visit`, `url`) VALUES
(1, 'www.isigame.net');

-- --------------------------------------------------------

--
-- Table structure for table `isicms_webstats_visits`
--

CREATE TABLE `isicms_webstats_visits` (
  `visits` int(11) NOT NULL DEFAULT '0',
  `date` date NOT NULL DEFAULT '0000-00-00',
  `day` tinytext NOT NULL,
  `month` tinytext NOT NULL,
  `ie` int(11) NOT NULL DEFAULT '0',
  `moz` int(11) NOT NULL DEFAULT '0',
  `opera` int(11) NOT NULL DEFAULT '0',
  `safari` int(11) NOT NULL DEFAULT '0',
  `text` int(11) NOT NULL DEFAULT '0',
  `brow_unknown` int(11) NOT NULL DEFAULT '0',
  `win` int(11) NOT NULL DEFAULT '0',
  `lin` int(11) NOT NULL DEFAULT '0',
  `mac` int(11) NOT NULL DEFAULT '0',
  `bsd` int(11) NOT NULL DEFAULT '0',
  `sun` int(11) NOT NULL DEFAULT '0',
  `so_unknown` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `isicms_application_errors`
--
ALTER TABLE `isicms_application_errors`
  ADD PRIMARY KEY (`id_error`);

--
-- Indexes for table `isicms_custom_emaildefaults`
--
ALTER TABLE `isicms_custom_emaildefaults`
  ADD PRIMARY KEY (`customer`);

--
-- Indexes for table `isicms_download_permissions`
--
ALTER TABLE `isicms_download_permissions`
  ADD PRIMARY KEY (`fileID`,`directory`,`filetype`,`fileperm`,`pkey`,`pvalue`);

--
-- Indexes for table `isicms_groups`
--
ALTER TABLE `isicms_groups`
  ADD PRIMARY KEY (`ID_GROUP`,`membergroup`);

--
-- Indexes for table `isicms_groups_principal`
--
ALTER TABLE `isicms_groups_principal`
  ADD PRIMARY KEY (`ID_GROUP`);

--
-- Indexes for table `isicms_log_activity`
--
ALTER TABLE `isicms_log_activity`
  ADD PRIMARY KEY (`month`,`day`,`year`),
  ADD KEY `hits` (`hits`);

--
-- Indexes for table `isicms_log_errors`
--
ALTER TABLE `isicms_log_errors`
  ADD PRIMARY KEY (`ID_ERROR`),
  ADD KEY `logTime` (`logTime`);

--
-- Indexes for table `isicms_log_online`
--
ALTER TABLE `isicms_log_online`
  ADD PRIMARY KEY (`identity`),
  ADD KEY `logTime` (`logTime`);

--
-- Indexes for table `isicms_log_users`
--
ALTER TABLE `isicms_log_users`
  ADD PRIMARY KEY (`ID_LOG`);

--
-- Indexes for table `isicms_membergroups`
--
ALTER TABLE `isicms_membergroups`
  ADD PRIMARY KEY (`ID_MEMBER`,`ID_GROUP`);

--
-- Indexes for table `isicms_members`
--
ALTER TABLE `isicms_members`
  ADD PRIMARY KEY (`ID_MEMBER`),
  ADD KEY `memberName` (`memberName`(30)),
  ADD KEY `dateRegistered` (`dateRegistered`),
  ADD KEY `memberGroup` (`memberGroup`),
  ADD KEY `birthdate` (`birthdate`),
  ADD KEY `posts` (`posts`),
  ADD KEY `lastLogin` (`lastLogin`),
  ADD KEY `lngfile` (`lngfile`(30));

--
-- Indexes for table `isicms_members_passwd`
--
ALTER TABLE `isicms_members_passwd`
  ADD PRIMARY KEY (`ID_MEMBER`,`passwd`,`pwdChange`);

--
-- Indexes for table `isicms_settings`
--
ALTER TABLE `isicms_settings`
  ADD PRIMARY KEY (`variable`(30));

--
-- Indexes for table `isicms_webstats_log`
--
ALTER TABLE `isicms_webstats_log`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `isicms_webstats_online`
--
ALTER TABLE `isicms_webstats_online`
  ADD PRIMARY KEY (`session_id`);

--
-- Indexes for table `isicms_webstats_pages`
--
ALTER TABLE `isicms_webstats_pages`
  ADD PRIMARY KEY (`page`);

--
-- Indexes for table `isicms_webstats_urls`
--
ALTER TABLE `isicms_webstats_urls`
  ADD PRIMARY KEY (`url`);

--
-- Indexes for table `isicms_webstats_visits`
--
ALTER TABLE `isicms_webstats_visits`
  ADD PRIMARY KEY (`date`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `isicms_application_errors`
--
ALTER TABLE `isicms_application_errors`
  MODIFY `id_error` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `isicms_log_errors`
--
ALTER TABLE `isicms_log_errors`
  MODIFY `ID_ERROR` smallint(5) UNSIGNED NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `isicms_webstats_log`
--
ALTER TABLE `isicms_webstats_log`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
