<?php

global $userlib;
$userlib = new userlib();

/**
 * user module library
 *
 * @package User.lib
 * @author rio
 * @version 0.0.1
 * @copyright Copyright (C) Sergio Rizzi
 */
class userlib {
	/**
	 * @var int class version
	 */
	public $version = '0.0.1';

	/**
	 * construcor: void
	 */
	function userlib() {
	}

	/***** FUNCTIONS *****/

	public function users_get($start = 0, $num = null) {
		global $user;
		if ($num == null) $LIMIT = '';
		else $LIMIT = "LIMIT ".$start." , ".$num;
		$query = "SELECT ID_MEMBER, memberName, emailAddress, memberGroup, passwd FROM ".$user["table"][0]." ORDER BY ID_MEMBER DESC ".$LIMIT;
		return _ISI_DBQUERY($query);
	}
	
	public function user_show($id) {
		global $user;
		$query = "SELECT * FROM ".$user["table"][0]." WHERE ID_MEMBER = '".$id."'";
		return _ISI_DBQUERY($query);
	}
	
	
	public function user_modify($id, $oldpassword = null, $password = null, $email = null, $gruppo = null, 
				$realname = null, $changepass = false, $fromroot = false) {
		global $user;
		$userdata = $this->user_show($id);
		$qpass = null;
		if ($email != null) {
			$errors = _ISI_CHEMAIL($id, $email);
			//print_r($errors);
			if ($errors[0][1] == false) {
				$retarray = array(false, $errors[0][2]);
				//print_r($retarray);
				return $retarray;
			}
		}
		
		if ($fromroot) $errors = _ISI_CHPASS($id, $userdata[0]["memberName"], $password);
		elseif ($oldpassword != null && $password != null) $errors = _ISI_CHPASS_WITHCHECKOLDPASS($id, $userdata[0]["memberName"], $oldpassword, $password);
		elseif ($changepass) $qpass = ", passwd = ''";
		if ($errors[0][1] == false) {
			$retarray = array(false, $errors[0][2]);
			//print_r($retarray);
			return $retarray;
		}
		
		
		$gruppo = $gruppo != null ? $gruppo : $userdata[0]["memberGroup"];
		$realname = $realname != null ? $realname : $userdata[0]["realName"];
		$query = "UPDATE ".$user["table"][0]." SET memberGroup = '".$gruppo."'".$qpass.", 
			realName = '".$realname."' WHERE ID_MEMBER = '".$id."'";

		_ISI_DBQUERY($query);
		
		return array(true, true);
	}
	
	public function user_get($id_user) {
		global $user;
		$query = "SELECT ID_MEMBER, memberName, emailAddress, memberGroup, passwd FROM ".$user["table"][0]." 
			WHERE ID_MEMBER = '".$id_user."'";
		return _ISI_DBQUERY($query);
	}
	
	public function users_group_list($groupsname, $start = 0, $num = null) {
		global $user, $inetd;
		if ($num == null) $LIMIT = '';
		else $LIMIT = "LIMIT ".$start." , ".$num;
		$array = array();
		for ($i = 0; $i < count($groupsname); $i++) {
			$query = "SELECT ".$inetd["dbprefix"]."membergroups.ID_MEMBER, memberName, emailAddress, 
					ID_GROUP, passwd FROM ".$user["table"][0]."
				JOIN ".$inetd["dbprefix"]."membergroups 
				ON ".$inetd["dbprefix"]."membergroups.ID_MEMBER =  ".$user["table"][0].".ID_MEMBER
				WHERE ID_GROUP = '"._ISI_GROUPID_FROMNAME($groupsname[$i])."' 
				ORDER BY ".$inetd["dbprefix"]."membergroups.ID_MEMBER DESC ".$LIMIT;
			$result = _ISI_DBQUERY($query);
			$array[$i] = $result;
		}
		return $array;
	}

	public function user_group_add($user_id, $id_group) {
		global $inetd, $user;
		$query = "SELECT ID_MEMBER FROM ".$user["table"][6]." WHERE ID_GROUP = '".$id_group."'";
		$reply = _ISI_DBQUERY($query);		
		if (!($reply[0][0] == $user_id)) {
			$grouptype = "SELECT grouptype FROM ".$user["table"][5]." WHERE ID_GROUP = '".$id_group."'";
			$reply = _ISI_DBQUERY($grouptype);
			if ($reply[0][0] == $user["groupescludercode"]) {
				$removefromgroups = "DELETE FROM ".$user["table"][6]." WHERE ID_MEMBER = '".$user_id."'"; 
				$reply = _ISI_DBQUERY($removefromgroups);
			}
			else {
				$groups1 = "SELECT ID_GROUP FROM ".$user["table"][5]." WHERE grouptype = '".$user["groupescludercode"]."'";
				$reply = _ISI_DBQUERY($groups1);
				for ($i = 0; $i < count($reply); $i++) { 
					$removefromgroups = "DELETE FROM ".$user["table"][6]." WHERE ID_MEMBER = '".$user_id."' 
						AND ID_GROUP = '".$reply[$i]["ID_GROUP"]."';";
					_ISI_DBQUERY($removefromgroups);
				}
			}
			$query = "INSERT INTO ".$user["table"][6]." (ID_MEMBER,ID_GROUP)
				VALUES ('".$user_id."', '".$id_group."');";
			_ISI_DBQUERY($query);
		}
	}
	
	public function user_group_remove($user_id, $id_group) {
		global $inetd;
		$query = "SELECT ID_MEMBER FROM ".$user["table"][6]." 
			WHERE ID_GROUP = '".$id_group."' AND ID_MEMBER = '".$user_id."'";
		$reply = _ISI_DBQUERY($query);
		if ($reply[0][0] == $user_id) {
			$query = "DELETE FROM ".$user["table"][6]."
				WHERE ID_MEMBER = '".$user_id."' AND ID_GROUP = '".$id_group."';";
			_ISI_DBQUERY($query);
		}
	}

	public function userAcceptedLicense() {
		global $id_user, $user;
		for ($i=0; $i<count($user["license"]); $i++) {
			if (_ISI_ISINGROUP($user["license"][$i], $id_user)) {
				$query = "SELECT acceptedLicense FROM ".$user["table"][0]." WHERE ID_MEMBER = '".$id_user."'";
				$result = _ISI_DBQUERY($query);
				if ($result[0][0] == '0')
					return false;
				else
					return true;
			}
		}
		return true;
	}
	
	public function userAcceptLicense() {
		global $id_user, $user;
		$query = "UPDATE ".$user["table"][0]." SET acceptedLicense = '1' WHERE ID_MEMBER = '".$id_user."'";
		_ISI_DBQUERY($query);
	}
}
?>
