<?php

/**
 * generic user page
 *
 * @package User.genericuser
 * @author rio
 * @version 0.0.1
 * @copyright Copyright (C) Sergio Rizzi
 */
class genericuser {
	/**
	 * @var int class version
	 */
	public $version = '0.0.2';

	/**
	 * constructor
	 */
	function genericuser($pagetoload = null) {
		global $userlib, $user, $_POST, $user_txt, $id_user, $userinfo, $inetd, $usercommon;
		
		// POSTs
		if ($_POST[$user["action"]] != null) {

			//editprofile
			if ($_POST[$user["action"]] == $user["actions"][1]) {
				$modify = false;
				$reload = true;
				$printerrpage = false;
				if (trim($_POST["oldpassword"]) != "" && trim($_POST["password"]) != "") {
					if ((trim($_POST["password"]) == trim($_POST["password2"]))) {
						$array = $userlib->user_modify($id_user, $_POST["oldpassword"], $_POST["password"]);
						if ($array != null && $array[0] == false) {
							$this->user_generic_edituser($array[1]);
							$reload = false;
							$modify = false;
						}
						else {
							$modify = true;
						}
					}
					else {
						$modify = false;
						$this->user_generic_edituser($user_txt['agent_modify_errors_redirect']);
						$reload = false;
					}
				}
				else {
					if (trim($_POST["oldpassword"]) == "" && trim($_POST["password"]) == "" && trim($_POST["password2"]) == "") {
						$modify = true;
					}
					else {
						$modify = false;
						$printerrpage = true;
					}
				}
				
				if ($modify) {
					$array = $userlib->user_modify($id_user, null, null, $_POST["email"], null, $_POST["realName"]);
					if ($array != null && $array[0] == false) {
						$this->user_generic_edituser($array[1]);
						$reload = false;
					}
					else {
						print('<h1 style="text-align: center;">'.$user_txt['msg_settings_success'].'</h1>');
						print('<p style="text-align: center; text-weight: bold;">'.$user_txt['msg_usermodifysuccess_redirect1'].'<br />'.$user_txt['root_msg_redirect_click'].' <a href="index.php?page=User">'.$user_txt['root_msg_redirect_here'].'</a> '.$user_txt['msg_usermodifysuccess_redirect2'].'</a></p>');
						
					}
					if ($reload) _ISI_RELOAD($inetd["GETpage"].'=User', "30");
				} 
				else {
					if ($printerrpage) {
						print('<h1 style="text-align: center;">'.$user_txt['msg_settings_notmodify'].'</h1>');
						print('<p style="text-align: center; text-weight: bold;">'.$user_txt['msg_usermodifysuccess_redirect1'].'<br />'.$user_txt['root_msg_redirect_click'].' <a href="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][1].'">'.$user_txt['root_msg_redirect_here'].'</a> '.$user_txt['msg_usermodifysuccess_redirect2'].'</a></p>');
						if ($reload) _ISI_RELOAD($inetd["GETpage"].'=User&'.$user["action"].'='.$user["actions"][1], "30");
					}
				}
			}
		}
		
		// GETs
		else {
			if (_ISI_ISGETVALID($user["action"], $user["actions"])) {
	
				//editprofile
				if ($_GET[$user["action"]] == $user["actions"][1]) $this->user_generic_edituser();
	
				else _ISI_NOTFOUND();
					
			}
			else {
				
				if ($userinfo["firstLogin"] > 0) $this->user_generic_edituser();

				elseif ($pagetoload == null) $usercommon->printUserDefaultPage();

				else _ISI_RELOAD($inetd["GETpage"].'='.$pagetoload);
			}
		}
	}
	
	public function user_generic_edituser ($msg = null) {
		global $userlib, $user, $userinfo, $id_user, $user_txt;
		print('<h1 align="center">'.$user_txt['change_profile_title'].'</h1>');
		if ($userinfo["firstLogin"] > 0)
			print('<h2 align="center" style="color: red;">'.$user_txt['warning_first_login'].'</h2>');
		if ($msg != null) print('<h3 align="center">'.$msg.'</h3>');

		print('<br />
		<span>'.$user_txt['pwd_disclaimer'].'</span>
		<ul>
			<li style="margin-left: -20px; list-style-type: none;"><span>'.$user_txt['pwd_disclaimer0'].'</span></li>
			<li><span>'.$user_txt['pwd_disclaimer1'].'</span></li>
			<li><span>'.$user_txt['pwd_disclaimer2'].'</span></li>
			<li><span>'.$user_txt['pwd_disclaimer3'].'</span></li>
			<li><span>'.$user_txt['pwd_disclaimer4'].'</span></li>
			<li><span>'.$user_txt['pwd_disclaimer5'].'</span></li>
			<li><span>'.$user_txt['pwd_disclaimer6'].'</span></li>
		</ul>');
		
		$usermail = $userlib->user_show($id_user);
		$usermail = $usermail[0]["emailAddress"];
	
		print('
		<table style="width: 100%"><tr>
		<form method="post" action="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][1].'" name="edituser">
		<input type="hidden" name="'.$user["action"].'" value="'.$user["actions"][1].'" />');


		print('						
				<td width="40%">
					<font size="2"><b>'.$user_txt['agent_change_oldpass'].'&nbsp;</b></font><br />
					<font size="1">'.$user_txt['agent_change_oldpass_descr'].'</font>
					</td>
					<td>
					<input type="password" name="oldpassword" size="20" maxlength="18" value="" />
					</td>
				</tr><tr>
				<td width="40%">
					<font size="2"><b>'.$user_txt['agent_change_pass1'].'&nbsp;</b></font><br />
					<font size="1">'.$user_txt['agent_change_pass1_descr'].'</font>
				</td>
				<td>
					<input type="password" name="password" size="20" maxlength="18" value="" />
				</td>
				</tr><tr>
				<td width="40%">
					<font size="2"><b>'.$user_txt['agent_change_pass2'].'&nbsp;</b></font><br />
					<font size="1">'.$user_txt['agent_change_pass2_descr'].'</font>
				</td>
				<td>
					<input type="password" name="password2" size="20" maxlength="18" value="" />
				</td>
				</tr><tr>
		
				<td width="40%">
					<font size="2"><b>'.$user_txt['name_surname'].'</b></font><br />
					<font size="1">'.$user_txt['name_surname_descr'].'</font>
				</td>
				<td>
					<input type="text" name="realName" size="40" maxlength="40" value="'.$userinfo["userfake"].'" />
				</td>
				</tr><tr>
	
				<td width="40%">
					<font size="2"><b>'.$user_txt['email'].'</b></font><br />
					<font size="1">'.$user_txt['email_descr'].'</font>
				</td>
				<td>
					<input type="text" name="email" size="30" maxlength="50" value="'.$usermail.'" />
				</td>
				</tr><tr>
	
	
		<tr><td colspan="2">
			<table style="border: 0px solid black; width: 100%;"><tr>
			<td style="width: 50%; text-align: center;">
				<input type="reset" value="'.$user_txt['root_button_reset'].'" /></td>
			<td style="width: 50%; text-align: center;">
				<input type="submit" value="'.$user_txt['root_button_modify'].'" /></td>
			</tr></table>
		</td>
	
		</table>
		</form>');
	}
}
?>
