<?php

function webstats() {
	global $webstats, $modrequest, $_SERVER;

	# online counter
	$httphost = $_SERVER["HTTP_HOST"];
	$add = false;
	$session = session_id();
	$time1 = date("U");
	$time = $time1 - $webstats["session_timeout"];
	$ip = $_SERVER["REMOTE_ADDR"]; // get the ip number of the user
	$query = "SELECT session_id, ip, url, time from ".$webstats["table"]["online"];
	$row = _ISI_DBQUERY($query);
	$first_visit = true;
	for ($i=0;$i<count($row);$i++) {
		if ($row[$i]["time"] < $time) {
			//delete all users were online before $timeout session
			$query = "DELETE FROM ".$webstats["table"]["online"]."
					WHERE time = '".$row[$i]["time"]."'";
			_ISI_DBQUERY($query);

			//if user last sessione was older than $timeout let's add a new webstat row
			if (($row[$i]["ip"] == $ip) && ($row[$i]["url"] == $httphost)) {
				$add = true;
			}
		}

		//let's delete this user entry
		if ($row[$i]["session_id"] == $session) {
			$first_visit = false;
			$query = "DELETE FROM ".$webstats["table"]["online"]."
					WHERE session_id = '".$row[$i]["session_id"]."' 
						AND ip = '".$row[$i]["ip"]."' 
						AND url = '".$row[$i]["url"]."'
						AND time = '".$row[$i]["time"]."'";
			_ISI_DBQUERY($query);
		}
	}

	if ($first_visit) $add = true;
	$query = "INSERT into ".$webstats["table"]["online"]." values('$session','$ip','$httphost','$time1')";
	_ISI_DBQUERY($query);
	$reply = _ISI_DBQUERY("SELECT count(*) from ".$webstats["table"]["online"]);
	$rows = $reply[0][0];

	## stats
	$user_agent = $_SERVER['HTTP_USER_AGENT'];
	$req_page_tmp = $_SERVER['REQUEST_URI'];
	if ($req_page_tmp == "/") $req_page = "/index.php";
	$req_page_pos = strpos($req_page_tmp, '&');
	if (!is_numeric($req_page_pos))  	$req_page = $req_page_tmp;
	else	$req_page = substr($req_page_tmp, 0, $req_page_pos);
	if (isset($modrequest) && $modrequest != "")	$req_page = $modrequest;
	else	$req_page = "index";

	
	
	$nottocount = false;
	for ($x = 0; $x < count($webstats["nottocount"]); $x++) {
		/*$len = strlen($webstats["nottocount"][$x]);
		if (substr($user_agent, 0, $len)  == $webstats["nottocount"][$x]) $nottocount = true;*/
		if (preg_match("/".$webstats["nottocount"][$x]."/i", $user_agent)) $nottocount = true;
		if ($webstats["nottocount"][$x] ==  $req_page) $nottocount = true;
	}
	if  (!$nottocount && $user_agent != " ") {
	 $ie = 0;$moz = 0;$opera = 0;$text = 0;$safari = 0;$brow_unknown = 0;$brow = "";
	 if (preg_match("/MSIE/i", $user_agent)) { $brow = "ie"; $ie = 1; }
	 elseif (preg_match("/Gecko/i", $user_agent)) {
	 	if (preg_match("/Safari/i", $user_agent)) {
	 		$brow = "safari"; $safari = 1;
	 	} else {$brow = "moz"; $moz = 1;}
	 }
	 elseif (preg_match("/Moz/i", $user_agent)) {$brow = "moz"; $moz = 1;}
	 elseif (preg_match("/Opera/i", $user_agent)) {$brow = "opera"; $opera = 1;}
	 elseif (preg_match("/Lynx/i", $user_agent) || preg_match("/Links/i", $user_agent) || preg_match("/w3m/i", $user_agent))
	 {$brow = "text"; $text = 1;}
	 else {$brow = "brow_unknown"; $brow_unknown = 1;}

	 $win = 0;$lin = 0;$mac = 0;$bsd = 0;$sun = 0;$so_unknown = 0;$so = "";
	 if (preg_match("/Windows/i", $user_agent)) {$so = "win"; $win = 1;}
	 elseif (preg_match("/Linux/i", $user_agent)) {$so = "lin"; $lin = 1;}
	 elseif (preg_match("/Mac/i", $user_agent)) {$so = "mac"; $mac = 1;}
	 elseif (preg_match("/BSD/i", $user_agent)) {$so = "bsd"; $bsd = 1;}
	 elseif (preg_match("/SunOS/i", $user_agent)) {$so = "sun"; $sun = 1;}
	 else {$so = "so_unknown"; $so_unknown = 1;}

	 $now = date("Y-m-d");
	 $day = date("D");
	 $month = date("M");
	 $query = "SELECT visits, ".$brow.", ".$so." from ".$webstats["table"]["visits"]." WHERE date = '".$now."'";
	 $ris = _ISI_DBQUERY($query);
	 if ($ris[0]["visits"] != "") {
	 	if ($add) {
	 		$query = "UPDATE ".$webstats["table"]["visits"]."
			SET visits = '".($ris[0]["visits"] + 1)."', 
			".$brow." = '".($ris[0][$brow] + 1)."', 
			".$so." = '".($ris[0][$so] + 1)."' WHERE date = '".$now."'";
	 		_ISI_DBQUERY($query);
	 	}
	 }
	 else {
	 	$query = "INSERT INTO ".$webstats["table"]["visits"]." ( visits , date , day , month , ie , moz , opera , safari , text , brow_unknown ,
					win , lin , mac , bsd , sun , so_unknown ) 
					VALUES ( '".$rows."', '".$now."', '".$day."', '".$month."', '".$ie."', '".$moz."', '".$opera."', '".$safari."', '".$text."', 
					'".$brow_unknown."', '".$win."', '".$lin."', '".$mac."', '".$bsd."', '".$sun."', '".$so_unknown."' )";
	 	_ISI_DBQUERY($query);
	 }

	 // log if browser or so is unknown (if is to log -> not in $nottologifunk list)
	 if ( ($brow == "brow_unknown" || $so == "so_unknown") )  {
	 	$nottolog = false;
	 	for ($y = 0; $y < count($webstats["nottologifunk"]); $y++) {
	 		if (preg_match("/".$webstats["nottologifunk"][$y]."/", $user_agent)) $nottolog = true;
	 	}
	 	if ($nottolog) {
		 	if ($brow == "brow_unknown") $user_agent = "brow: ".$user_agent;
		 	else $user_agent = "so: ".$user_agent;
		 	$query = "INSERT INTO ".$webstats["table"]["log"]." ( log ) VALUES ('".$user_agent."' )";
		 	_ISI_DBQUERY($query);
	 	}
	 }

	 $query = "SELECT visit, page from ".$webstats["table"]["pages"]." WHERE page = '".$req_page."'";
	 $ris = _ISI_DBQUERY($query);
	 if ($ris[0]["page"] != "") {
	 	$totvisit = $ris[0]["visit"] + 1;
	 	$query = "UPDATE ".$webstats["table"]["pages"]." SET visit = '".$totvisit."' WHERE page = '".$req_page."'";
	 	_ISI_DBQUERY($query);
	 }
	 else {
	 	$query = "INSERT INTO ".$webstats["table"]["pages"]." ( visit , page ) VALUES ( 1 , '".$req_page."' )";
	 	_ISI_DBQUERY($query);
	 }

	 if ($add) {
		 $query = "SELECT visit, url from ".$webstats["table"]["urls"]." WHERE url = '".$httphost."'";
		 $ris = _ISI_DBQUERY($query);
		 if ($ris[0]["url"] != "") {
		 	$totvisit = $ris[0]["visit"] + 1;
		 	$query = "UPDATE ".$webstats["table"]["urls"]." SET visit = '".$totvisit."' WHERE url = '".$httphost."'";
		 	_ISI_DBQUERY($query);
		 }
		 else {
		 	$query = "INSERT INTO ".$webstats["table"]["urls"]." ( visit , url ) VALUES ( 1 , '".$httphost."' )";
		 	_ISI_DBQUERY($query);
		 }
	 }	 
	 //else  browser is a bot
	}

}
##
?>
