<?php

### boot check
global $id_user; if (!$id_user) {echo $modname.": boot missing"; exit(1);}

# load inetd main graphics library
include_once ('libs/graphlib.php');
include_once ('libs/class.htmlform_4.0.php');

#
# CONSOLE MODE
#
function _ISI_CONSOLE($param) {
	include('console.php'); new ISIconsole($param);
	# shutdown
	_ISI_DBDISCONN();
	exit(0);	
}


###
# get user's module request
$modrequest = (isset($_GET[$inetd["GETpage"]]) ? $_GET[$inetd["GETpage"]] : null);
if ($id_user == "Guest") $userinfo["username"] = "Guest";

// library init>
_ISI_INITBROWSER();
_ISI_INITLAYOUT();
_ISI_INITTEMPLATE();
_ISI_INITDNSURL();
// <init


/**
 * init client browser detection
 *
 * void
 */
function _ISI_INITBROWSER() {
	global $inetd;
	$inetd["client_brow"] = preg_match("/MSIE/i", $inetd["user_agent"]) ? "ie" : "mozilla"; //determinate client browser
	$inetd["client_brow"] = preg_match("/Opera/i", $inetd["user_agent"]) ? "opera" : $inetd["client_brow"];
	$inetd["client_brow"] = preg_match("/Safari/i", $inetd["user_agent"]) ? "safari" : $inetd["client_brow"];
	//echo $inetd["client_brow"];
}

/**
 * loads an external website
 * 
 * void
 */
function _ISI_LOADEXTERNAL($directory) {
	global $inetd, $EXTPATH;
	$EXTPATH = $inetd["externalpath"].'/'.$directory.'/';
	@include($EXTPATH.'/index.php');
	# visits counter module
	if ($inetd["webstatscount"]) inetd('Webstats','counter');
	# shutdown
	_ISI_DBDISCONN();
	exit(0);
}

/**
 * init host based layout
 *
 * void
 */
function _ISI_INITLAYOUT() {
	global $locklayout, $layout, $inetd, $template, $_SERVER;
	if ($inetd["hosttemplate"]) {
		$httphost = $_SERVER["HTTP_HOST"];
		for ($i = 0; $i < count($inetd["host"]); $i++) {
			if ($httphost == $inetd["host"][$i] && isset($inetd["layout"][$i])) {
				$skiptodefault = false;
				if ($inetd["iprestrict"][$i] != false) {
					$client_ip = $_SERVER["REMOTE_ADDR"];
					$tmparray = explode(" ", $inetd["iprestrict"][$i]);
					for ($x = 0; $x < count($tmparray); $x++) {
						if (preg_match("/".$tmparray[$x]."/i", $client_ip)) {
							$skiptodefault = true;
						}
					}
				}
				if ($skiptodefault) {
					$inetd["layout"][$i] = $layout;
					$inetd["template"][$i] = $template;
				}
				else {
					if (isset($inetd["external"][$i])) {
						_ISI_LOADEXTERNAL($inetd["template"][$i]);
					}
					else {
						$layout = $inetd["layout"][$i];
						if ($inetd["locklayout"][$i] == true) $locklayout = true;
					}
					if (isset($inetd["permitlogin"][$i]))
						if ($inetd["permitlogin"][$i] == false) $inetd["loginenabled"] = false;
						else $inetd["loginenabled"] = true;
				}
				if (isset($inetd["logingroupspermitted"][$i]))
					$inetd["logingroups"] = $inetd["logingroupspermitted"][$i];
				
				$i = count($inetd["host"]);
			}
		}
	}
	$inetd["imgpath"] = $inetd["imgorigpath"].'/'.$layout;
}

/**
 * init host based template
 *
 * void
 */
function _ISI_INITTEMPLATE() {
	global $locktemplate, $template, $inetd, $_SERVER, $defaulttemplate;
	$defaulttemplate = $template;
	if ($inetd["hosttemplate"]) {
		$httphost = $_SERVER["HTTP_HOST"];
		for ($i = 0; $i < count($inetd["host"]); $i++) {
			if ($httphost == $inetd["host"][$i] && isset($inetd["template"][$i])) {
				$template = $inetd["template"][$i];
				if ($inetd["locktemplate"][$i] == true) $locktemplate = true;
				$i = count($inetd["host"]);
			}
		}
	}
}


/**
 * init url automatic management
 *
 * void
 */
function _ISI_INITDNSURL() {
	global $inetd, $_SERVER, $modrequest;
	if ($_SERVER["HTTPS"] == "on") $inetd["url"] = "https://";
	#$inetd["url"] = "https://";
	$serverstr = $_SERVER['REQUEST_URI'];
	$thereisindex = strpos($serverstr, "index.php");
	$thereisrss = strpos($serverstr, "rss.php");
	$thereisssl = strpos($serverstr, "ssl.php");
	if ($thereisindex != '') $inetd["basepath"] = substr($serverstr, 0, ($thereisindex - 1));
	elseif ($thereisrss != '') $inetd["basepath"] = substr($serverstr, 0, ($thereisrss - 1));
	elseif ($thereisssl != '') $inetd["basepath"] = substr($serverstr, 0, ($thereisssl - 1));
	else $inetd["basepath"] = substr($serverstr, 0, (strlen($serverstr) - 1));
	$inetd["url"] = $inetd["url"].$inetd["dns"].$inetd["basepath"];
	//$inetd["admin"]["url"] = $inetd["admin"]["url"].$inetd["dns"].$inetd["basepath"];
	// get further requested url
	$thereismodule = strpos($serverstr, $inetd["GETpage"].'='.$modrequest);
	if ($thereismodule != '') $inetd["furtherurl"] = substr($serverstr,
	($thereismodule + (strlen($inetd["GETpage"].'='.$modrequest))), strlen($serverstr));
	// ssl library patch>
	$thereismodules = strpos($inetd["url"], $inetd["modpath"]);
	if ($thereismodules != '') $inetd["url"] = substr($inetd["url"], 0, ($thereismodules - 1));
	// <ssl
}

/**
 * return content of a page
 *
 * void
 */
function _ISI_GETCONTENT($in_layout, $file) {
	global $id_user, $inetd, $layout;
	if (is_file($inetd["includepath"].'/'.$in_layout.'/'.$file))
		return file_get_contents($inetd["includepath"].'/'.$in_layout.'/'.$file);
	else
		echo "Content not found";
}

/**
 * check for permissions when downloading a file
 * db table - $inetd["download_table"]
 * main GET - $inetd["download"]
 * 
 * URL INFORMATIONS
 * page=Getfile   is the GET to make engine understand that a generic download is to be started
 * $_GET["file"]  if matches $inetd["download"] will start a filesystem download
 * $_GET["dir"]   is the first directory starting from repository
 * $_GET["type"]  is the file type to download
 * $_GET["id"]    is the ID of the file, to be joinen with the right table (if is public, is the name of file)
 * $_GET["name"]  is the filename that client will download
 * FINAL USAGE IS LIKE:
 * index.php?page=Getfile&file=download&dir=contracts&type=pdf&id=1&name=contract.pdf
 * or
 * index.php?page=Getfile&file=download&dir=contracts&id=company-facsimile.pdf&name=facsimile.pdf
 * 
 * TABLE:
 * k fileID (0|ID) -> 0 is to be used on (as there is no contract with id = 0): - page=Getfile&id=$fileID
 *  - publics files
 *  - group permissions
 *  as these are not single-user permissions. For the others a DB join is to be used
 * k directory (publics|contracts|locontracts|...) -> is the initial directory - page=Getfile&dir=$directory
 * k filetype ( |pdf|xls|...) -> is the file type to download - page=Getfile&type=$filetype
 * k fileperm (public|group|user|guest) -> is the permission type used to understand pkey and pvalue
 * pkey ( |groupID|userID|ip,sessid) -> depends on fileperm
 * pvalue ( |$groupID|$userID|$ip,$sessid) -> depends on fileperm
 * timeline (unixtime|NULL) -> end time for downloading file, if NULL is permanent
 * 
 * @param string $directory is the directory ($_GET["dir"] - directory (contracts|public|locontracts|...) -> page=Getfile&dir=$directory)
 * @param string $fileID is the file id ($_GET["id"] - fileID (filename for publics file, ID of a table for protected ones)
 * @param string $filetype is the optional filetype ($_GET["type"] - filetype ( |xls|pdf|...) -> page=Getfile&type=$filetype)
 * @return mixed can be a boolean (false, no permission) or the path to the file
 */
function _ISI_CHECKREPOPERMS ($directory, $fileID, $filetype = null) {
	global $id_user, $inetd, $_SERVER;
	$return = false;
	$phpsessid = session_id();
	$clientip = $_SERVER["REMOTE_ADDR"];
	$now = time();
	
	// WE STARTS TO SEE IF THIS FILE IS PUBLIC
	$query = "SELECT fileID FROM ".$inetd["download_table"]."
				WHERE directory = '".$directory."' AND fileperm = 'public';";
	$reply = _ISI_DBQUERY($query);
	if (count($reply) > 0) $return = $fileID;
	
	// FILE IS NOT PUBLIC
	else {
		
		// LET'S SEE WHERE TO GET FILE PATH
		switch ($directory) {
			case 'reports':
				$path = $fileID;
				break;
		}
		// GROUP SEARCH
		if (is_numeric($id_user)) {
			if ($filetype == null) $filetype = '';
			$query = "SELECT * FROM ".$inetd["download_table"]."
						    WHERE directory = '".$directory."' AND fileperm = 'group';";
			$reply = _ISI_DBQUERY($query);
			if (count($reply) > 0) {
				for ($i = 0; $i < count($reply); $i++) {
					if ($reply[$i]["pkey"] == "groupID") {
						$groupid = $reply[$i]["pvalue"];
						if (_ISI_ISINGROUP(_ISI_GROUPNAME_FROMID($groupid), $id_user)) {
							$return = $path;
							break;
						}
					}
				}
			}
		}
		
		
		// USER SEARCH (not used till now 20100417)
		if ($return == false) {
			$query = "SELECT * FROM ".$inetd["download_table"]."
						    WHERE directory = '".$directory."' AND fileperm = 'user';";			
		}

		// GUEST SEARCH
		if ($return == false) {
			$query = "SELECT * FROM ".$inetd["download_table"]."
						    WHERE directory = '".$directory."' AND fileperm = 'guest'
						    AND fileID = '".$fileID."';";			
			$reply = _ISI_DBQUERY($query);
			if (count($reply) > 0) {
				$valid = true;
				for ($i = 0; $i < count($reply); $i++) {
					if ( (($reply[$i]["pkey"] == "ip") && ($reply[$i]["pvalue"] != $clientip))
						 && (trim($reply[$i]["filetype"]) == $filetype) ) {
						$valid = false;
					}
					else
						if ($reply[$i]["timeline"] < $now) {
							$valid = false;
						}
					
					if ( (($reply[$i]["pkey"] == "sessid") && ($reply[$i]["pvalue"] != $phpsessid)) 
						&& (trim($reply[$i]["filetype"]) == $filetype) ) {
						$valid = false;
					}
					else
						if ($reply[$i]["timeline"] < $now) {
							$valid = false;
						}
				}
				if ($valid) $return = $path;
			}
		}
	}
	
	//echo $id_user." || ".$clientip." || ".$phpsessid." || ".$now." || ".$return." "; exit(0);
	return $return;
}
/**
 * write permission on DB to let client download a file
 */
function _ISI_WRITEREPOPERMS ($fileID, $directory, $fileperm, $in_pkey = null, $in_pvalue = null, 
								$in_timeline = null, $in_groupid = null, $in_userid = null, $filetype = null) {
	global $inetd;
	if ($in_groupid != null) {	
		$fileperm = 'group';
		$pkey = "'groupID'";
		$pvalue = $in_pvalue;
	}
	elseif ($in_userid != null) {
		$fileperm = 'user';	
		$pkey = "'userID'";
		$pvalue = $in_pvalue;
	}
	else {
		$pkey = ($in_pkey != null) ? "'".$in_pkey."'": "''";
		$pvalue = ($in_pvalue != null) ? "'".$in_pvalue."'": "''";
	}
	if ($filetype == null) $filetype = '';
	$in_timeline = ($in_timeline != null) ? "'".$in_timeline."'": "NULL";
	$query = "INSERT INTO ".$inetd["download_table"]." (fileID, directory, filetype, fileperm, pkey, pvalue, timeline)
				VALUES ('".$fileID."', '".$directory."', '".$filetype."', '".$fileperm."', ".$pkey.", ".$pvalue.", ".$in_timeline.")
				ON DUPLICATE KEY UPDATE fileID = fileID";
	_ISI_DBQUERY($query);
}
/**
 * create a link based on input data
 */
function _ISI_CREATEREPOLINK($directory, $fileID, $name = null, $in_filetype = null) {
	global $inetd;
	$filetype = null;
	if ($in_filetype != null) $filetype = "&type=".$in_filetype;
	if ($name == null) $name = $fileID;
	return "index.php?page=Getfile&file=".$inetd["download"]."&dir=".$directory.$filetype."&id=".$fileID."&name=".$name;
}
/**
 * return php header to download a file
 */
function _ISI_PHPHEADER_DOWNLOAD($file, $in_filename, $type){
	
	switch ($type) {
		case 'html':
			echo $file;
			exit(0);
		case 'file':
			if (!is_file($file)) { die("<b>404 File not found!</b>"); }
			$file_extension = strtolower(substr(strrchr(basename($file),"."),1));
			$filename = ($in_filename != null) ? $in_filename : basename($file);
			$len = filesize($file);
			$output = @file_get_contents($file);
			break;
		case 'content':
			$file_extension = strtolower(substr(strrchr(basename($in_filename),"."),1));
			$filename = $in_filename;
			$len = null;
			$output = $file;
			break;
	}

	//This will set the Content-Type to the appropriate setting for the file
	switch( $file_extension ) {
		case "pdf": $ctype="application/pdf"; break;
		case "exe": $ctype="application/octet-stream"; break;
		case "zip": $ctype="application/zip"; break;
		case "rtf":
		case "doc": $ctype="application/msword"; break;
		case "csv":
		case "xls": $ctype="application/vnd.ms-excel"; break;
		case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
		case "gif": $ctype="image/gif"; break;
		case "png": $ctype="image/png"; break;
		case "jpeg":
		case "jpg": $ctype="image/jpg"; break;
		case "mp3": $ctype="audio/mpeg"; break;
		case "wav": $ctype="audio/x-wav"; break;
		case "mpeg":
		case "mpg":
		case "mpe": $ctype="video/mpeg"; break;
		case "mov": $ctype="video/quicktime"; break;
		case "avi": $ctype="video/x-msvideo"; break;
		case "txt": $ctype="text/plain"; break;

		//The following are for extensions that shouldn't be downloaded (sensitive stuff, like php files)
		case "php": die("<b>Cannot be used for ". $file_extension ." files!</b>");
		case "htm": die("<b>Cannot be used for ". $file_extension ." files!</b>");
		case "html": die("<b>Cannot be used for ". $file_extension ." files!</b>");
		break;

		default: $ctype="application/force-download";
	}

	// i txt su windows han bisogno di \n\r
	if ($ctype == "text/plain") {
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		if (preg_match("/Windows/i", $user_agent)) {
			$winconversion = true;
		}
	}
	
	//Begin writing headers
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Cache-Control: public");
	header("Content-Description: File Transfer");

	//Use the switch-generated Content-Type
	header("Content-Type: $ctype");

	//Force the download
	$header="Content-Disposition: attachment; filename=\"".$filename."\";";
	header($header);
	header("Content-Transfer-Encoding: binary");
	//if ($len != null) header("Content-Length: ".$len);
	if ($winconversion) {
		// @todo la lenght e' diversa quando faccio download con winconversion: sarebbe da ricalcorale
		$output = str_replace(array("\r\n","\r","\n"),"\r\n",$output);
	} else if ($len != null) header("Content-Length: ".$len);
	echo $output;
	return;
}

/**
 * go to "NotFound" page
 *
 * void
 */
function _ISI_NOTFOUND() {
	global $inetd, $layout, $locale;
	if (is_file($inetd["includepath"].'/'.$layout.'/locale/'.$locale.'/'.$inetd["NotFound"].'.php')
	|| is_file($inetd["includepath"].'/'.$layout.'/'.$inetd["NotFound"].'.php'))
		_ISI_RELOAD($inetd["GETpage"].'=NotFound');
	else
		echo "NotFound page cannot be included";
	exit(0);
}

/**
 * reload requested url using javascript
 *
 * void
 */
function _ISI_RELOAD($url, $timeout = null) {
	global $inetd;
	if ($timeout != null && is_numeric($timeout)) $timeout = $timeout."00";
	else $timeout = "0";
	$out = '
	<script type="text/javascript">
		function _ISI_RELOAD() {
			location.href = "'.$inetd["url"].'/index.php?'.$url.'";
		}
		setTimeout(\'_ISI_RELOAD()\', '.$timeout.');
	</script>';
	echo $out;
	if ($timeout == "0") exit(0);
}

/**
 * close this window
 *
 * void
 */
function _ISI_CLOSE($timeout = null) {
	global $inetd;
	if ($timeout != null && is_numeric($timeout)) $timeout = $timeout."00";
	else $timeout = "0";
	$out = '
	<script type="text/javascript">
	function _ISI_CLOSE() {
	window.close();
}
setTimeout(\'_ISI_CLOSE()\', '.$timeout.');
</script>';
	echo $out;
	if ($timeout == "0") exit(0);
}

/**
 * redirect to a url
 *
 * void
 */
function _ISI_REDIRECT($url) {
	print ('<div align="center">Please redirect your browser to <a href="'.$url.'">'.$url.'</a></div>
	<script type="text/javascript">
	<!--
		window.location = "'.$url.'"
	//-->
	</script>');
	exit(0);
}

/**
 * send email for password recovery
 *
 * void
 */
function _ISI_SENDLOSTPWD($in_username) {
	global $inetd, $locale;
	$reply = _ISI_DBQUERY("SELECT ID_MEMBER,emailAddress FROM ".$inetd["dbprefix"]."members
		WHERE memberName='".$in_username."'");

	if (($reply[0]["ID_MEMBER"] != "") && ($reply[0]["emailAddress"] != "")) {
		// randomly generate a new password
		mt_srand(time());
		$password = crypt(mt_rand(-100000, 100000));
		// remove all non alpha-numeric characters
		$password = preg_replace("/\W/", '', $password);
		//limit it to 10 characters max
		$newpass = substr($password, 0, 10);
		//$queryPasswdPart = $this->_ISI_MD5_HMAC( array($member['passwrd1'], strtolower($member['user'])) );
		_ISI_CHPASS($reply[0]["ID_MEMBER"], $in_username, $newpass);
		
		if ($locale == "it_IT") {
			$subject = "Recupero Password";
			$message = "Ciao ".$in_username.",\n la procedura di recupero password e' stata completata con successo.\n\n";
			$message .= "La nuova password: $newpass";
			$message .= "\n\nArrivederci!";
		}
		elseif ($locale == "en_GB") {
			$subject = "Password Recovery";
			$message = "Hi ".$in_username.",\n password recovery procedure is now successfully complete.\n\n";
			$message .= "New password is: $newpass";
			$message .= "\n\nSee you again!";
		}
		//_ISI_SENDMAIL($to, $subject, $message, $from = null, $from_mail = null,
		_ISI_SENDMAIL ($reply[0]["emailAddress"], $subject, $message, "ISIcms");
	}
}

/**
 * get user id
 *
 * @return int user id
 */
function _ISI_GETIDUSER() {
	global $id_user;
	return $id_user;
}

/**
 * get username
 *
 * return an username or null
 */
function _ISI_GETIDUSER_FROMUSERNAME($in_username) {
	global $inetd;
	$reply = _ISI_DBQUERY("SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."members
		WHERE memberName='".$in_username."'");
	if ($reply[0][0] != "") return $reply[0][0];
	else return null;
}


/**
 * get main group for a user
 * 
 * string
 */
function _ISI_USERMAINGROUP($user_id) {
	global $inetd;
	$reply = _ISI_DBQUERY("SELECT ".$inetd["dbprefix"]."groups_principal.membergroup
					FROM ".$inetd["dbprefix"]."groups_principal
					JOIN ".$inetd["dbprefix"]."members
					ON ".$inetd["dbprefix"]."members.memberGroup = 
						".$inetd["dbprefix"]."groups_principal.ID_GROUP
					WHERE ID_MEMBER='".$user_id."'");
	return $reply[0][0];
}

/**
 * return main group id for a template (to set in template configuration $inetd["template_maingroup"] = ID)
 * never 0 as is the Administrator group 
 * 
 * int (default 1)
 */
function _ISI_TEMPLATEMAINGROUP() {
	global $inetd;
	if ($inetd["template_maingroup"] != '' && $inetd["template_maingroup"] > 0) {
		return $inetd["template_maingroup"];
	}
	else { 
		return 1;
	}
}



/**
 * when locale is loaded init available groups and store them into $groups
 *
 * void
 */
function _ISI_LOADGROUPS() {
	global $inetd, $groups, $locale;
	$query = "SELECT ID_GROUP, membergroup, ".$locale."descr FROM ".$inetd["dbprefix"]."groups ORDER BY ID_GROUP ASC";
	$reply = _ISI_DBQUERY($query);
	for ($i = 0; $i < count($reply); $i++) {
		if (trim($reply[$i]['membergroup']) != "" && $reply[$i]['membergroup'] != null)
			$groups[$i]['gid'] = $reply[$i]['ID_GROUP'];
			$groups[$i]['name'] = $reply[$i]['membergroup'];
			$groups[$i]['descr'] = $reply[$i][$locale.'descr'];
	}
}

/**
 * when session starts, init array where groups of a user are stored 
 * 
 * void
 */
function _ISI_INITUSERGROUPS($user_id = null) {
	global $inetd, $id_user, $userinfo;
	$id = $id_user; $thisuser = true;
	if ($user_id != null) {
		$id = $user_id;
		$thisuser = false;
	}
	$query = "SELECT membergroup FROM ".$inetd["dbprefix"]."groups JOIN
		".$inetd["dbprefix"]."membergroups ON 
		".$inetd["dbprefix"]."membergroups.ID_GROUP = ".$inetd["dbprefix"]."groups.ID_GROUP
		WHERE ".$inetd["dbprefix"]."membergroups.ID_MEMBER = '".$id."'";
	$reply = _ISI_DBQUERY($query);	
	for ($i = 0; $i < count($reply); $i++) {
		if (trim($reply[$i][0]) != "" && $reply[$i][0] != null)
			if ($thisuser) {
				$userinfo["groups"][$i] = $reply[$i][0];
			}
			else {
				$return[$i] = $reply[$i][0];
			}
	}
	if (!$thisuser) return $return;
}


/**
 * check if a user is part of a group
 *
 * boolean
 */
function _ISI_ISINGROUP($groupname, $user_id = null) {
	global $id_user, $userinfo;
	if ($user_id != null) {
		$usergroups = _ISI_INITUSERGROUPS($user_id);
	}
	else {
		$usergroups = $userinfo['groups'];
	}
	$groupfound = false;
	for ($i = 0; $i < count($usergroups); $i++) {
		if ($usergroups[$i] == $groupname) {
			$groupfound = true;
			break; 
		}
	}
	return $groupfound;
}

/**
 * get group id from group name
 *
 * int
 */
function _ISI_GROUPID_FROMNAME($groupname) {
	global $inetd;
	$query = "SELECT ID_GROUP FROM ".$inetd["dbprefix"]."groups WHERE membergroup = '".$groupname."'";
	$reply = _ISI_DBQUERY($query);
	return $reply[0][0];
}

/**
 * get group name from group id
 *
 * int
 */
function _ISI_GROUPNAME_FROMID($groupid) {
	global $inetd;
	$query = "SELECT membergroup FROM ".$inetd["dbprefix"]."groups WHERE ID_GROUP = '".$groupid."'";
	$reply = _ISI_DBQUERY($query);
	return $reply[0][0];
}




/**
 * sends email to an user
 *
 * void
 */
function _ISI_SENDMAIL_HTML($to, $subject, $message, $from = null, $from_mail = null, 
							$attachment_filepath = null, $attachment_filename = null, 
							$cc = null, $cc_mail = null, $bcc = null, $bcc_mail = null, $winconvert = false) {
	_ISI_SENDMAIL($to, $subject, $message, $from, $from_mail, $attachment_filepath, 
					$attachment_filename, $cc, $cc_mail, true, $bcc, $bcc_mail, $winconvert);
}

function _ISI_SENDMAIL($to, $subject, $message, $from = null, $from_mail = null, 
		$attachment_filepath = null, $attachment_filename = null, $cc = null,
		$cc_mail = null, $htmlbody = null, $bcc = null, $bcc_mail = null, $winconvert = false) {
	global $inetd;
	
	if ($inetd["testsite"]){
		return true;
	}
	
	/*
	 * CALL EXAMPLE:
	 * _ISI_SENDMAIL("rio@isigame.net", "prova", "messaggio", "rio_", "rio@localhost", 
	 * 	"/home/rio/.workspace/isicms/develop/repository/test/2009-05-11/1/test.pdf", "test.pdf", null, null, true);
	 */
	$with_attach = false;

	//create a boundary string. It must be unique so we use the MD5 algorithm to generate a random hash
	$random_hash = md5(date('r', time()));
	
	/*
	 * is a mail with attachment
	 */
	if (file_exists($attachment_filepath)) {
		$with_attach = true;
		$file_extension = strtolower(substr(strrchr(basename($attachment_filepath),"."),1));
		//add boundary string and mime type specification
		$mime = "MIME-Version: 1.0\r\nContent-Type: multipart/alternative; boundary=".$random_hash."\r\n";
		//read the atachment file contents into a string, encode it with MIME base64 and split it into smaller chunks
		$attach_body_tmp = file_get_contents($attachment_filepath);
		if ( ($winconvert == true) || ($file_extension == "txt") ) $attach_body_tmp = str_replace(array("\r\n","\r","\n"),"\r\n",$attach_body_tmp);
		$attach_body = chunk_split(base64_encode($attach_body_tmp));

		//build attachment
		if ($attachment_filename != null) $filename = $attachment_filename;
		else $filename = $attachment_filepath;

		$file_extension = strtolower(substr(strrchr(basename($filename),"."),1));
		switch( $file_extension ) {
			case "pdf": $ctype="application/pdf"; break;
			case "exe": $ctype="application/octet-stream"; break;
			case "zip": $ctype="application/zip"; break;
			case "rtf": $ctype="multipart/mixed"; break;
			case "doc": $ctype="application/msword"; break;
			case "csv": $ctype="multipart/mixed"; break;
			case "xls": $ctype="application/vnd.ms-excel"; break;
			case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
			case "gif": $ctype="image/gif"; break;
			case "png": $ctype="image/png"; break;
			case "jpeg": $ctype="image/jpg"; break;
			case "jpg": $ctype="image/jpg"; break;
			case "mp3": $ctype="audio/mpeg"; break;
			case "wav": $ctype="audio/x-wav"; break;
			case "mpeg": $ctype="video/mpeg"; break;
			case "mpg": $ctype="video/mpeg"; break;
			case "mpe": $ctype="video/mpeg"; break;
			case "mov": $ctype="video/quicktime"; break;
			case "avi": $ctype="video/x-msvideo"; break;
			case "txt": $ctype="multipart/mixed"; break;
			case "php": $ctype="multipart/mixed"; break;
			case "htm": $ctype="multipart/mixed"; break;
			case "html": $ctype="text/plain"; break;
			default: $ctype="application/force-download";
		}
		
		
		$attach_header = "--".$random_hash."\r
Content-Type: ".$ctype."\r
Content-Disposition: attachment; filename=\"".$filename."\"\r
Content-Transfer-Encoding: base64"."\r\n\r\n";
		$attach_foot = "\r\n"."--".$random_hash."--"."\r\n";
		$attachment = $attach_header.$attach_body.$attach_foot;
	}

	/*
	 * is a mail without attachment
	 */
	else {
		$mime = "MIME-Version: 1.0\r\n";
	}
	
	$from_mail = $from_mail != null ? $from_mail : $inetd["webmaster_mail"];
	$from = $from != null ? $from : $from_mail;

	// If the recipient list isn't an array, make it one.
	$to_array = is_array($to) ? $to : array($to);

	// If the cc list isn't an array, make it one.
	if ($cc_mail != null) {
		if (!is_array($cc_mail)) { 
			$ccmail_array = array($cc_mail);
			$cc_array = array($cc);
		}
		else {
			$ccmail_array = $cc_mail;
			$cc_array = $cc;
		}
	}

	// If the cc list isn't an array, make it one.
	if ($bcc_mail != null) {
		if (!is_array($bcc_mail)) {
			$bccmail_array = array($bcc_mail);
			$bcc_array = array($bcc);
		}
		else {
			$bccmail_array = $bcc_mail;
			$bcc_array = $bcc;
		}
	}
	
	// Get rid of slashes and entities.
	$subject = _ISI_UNHTMLENTITIES(stripslashes($subject));
	// Make the message use \r\n's only.
	$message = str_replace(array("\r", "\n"), array('', "\r\n"), stripslashes($message));

	// Construct the mail headers...
	$headers = 'From: "' . addcslashes($from, '<>[]()\'\\"') . '" <' . $from_mail . ">\r\n";
	if ($cc_mail != null) {
		$headers .= 'Cc: ';
		for ($n=0;$n<count($ccmail_array);$n++) {
			$headers .= '"' . addcslashes($cc_array[$n], '<>[]()\'\\"') . '" <' . $ccmail_array[$n] . ">";
			if ($n<(count($ccmail_array)-1)) $headers .= ',';
			else $headers .= "\r\n";
		}
	}
	if ($bcc_mail != null) {
		$headers .= 'Bcc: ';
		for ($n=0;$n<count($bccmail_array);$n++) {
			$headers .= '"' . addcslashes($bcc_array[$n], '<>[]()\'\\"') . '" <' . $bccmail_array[$n] . ">";
			if ($n<(count($bccmail_array)-1)) $headers .= ',';
			else $headers .= "\r\n";
		}
	}
	$headers .= $from !== null ? 'Reply-To: '.$from.' <' . $from_mail . ">\r\n" : '';
	$headers .= 'Return-Path: <' . $from_mail . '>'."\r\n";
	$headers .= 'Date: ' . gmdate('D, d M Y H:i:s') . ' +0000';
	//print("<pre>".$headers."</pre>");exit(0);

	if ($htmlbody == true) {
		if ($with_attach != true)
			$headers .= "\r\n".'Content-Type: multipart/alternative; boundary='.$random_hash."\r\n";
		$text_plain = "--".$random_hash."\r
Content-Type: text/plain; charset=utf-8"."\r\n\r\n";
		$text_html = "--".$random_hash."\r
Content-Type: text/html; charset=utf-8"."\r\n\r\n";
		$text_end = "--".$random_hash."--";
		if ($with_attach != true)
			$message = $text_plain.$message."\r\n\r\n".$text_html.$message."\r\n\r\n".$text_end;
		else
			$message = $text_plain.$message."\r\n\r\n".$text_html.$message."\r\n\r\n";
	}
	
	// SMTP or sendmail?
	if ($inetd["mailtype"] == 0)
		foreach ($to_array as $to)
			$mail_result = mail(str_replace(array("\r", "\n"), array('', ' '), $to), str_replace(array("\r", "\n"), array('', ' '), $subject), $message, $headers, $cc_mail, $bcc_mail);
	elseif ($inetd["mailtype"] == 1) {
		if ($with_attach) {
			if (!$htmlbody)
				$message = "--".$random_hash."\r
Content-Type: text/plain; charset=\"utf-8\"\r
Content-Transfer-Encoding: quoted-printable.\r\n\r\n".$message."\r\n\r\n".$attachment;
				/*$message = "--".$random_hash."\r
Content-Type: text/plain; charset=\"utf-8\"\r
Content-Transfer-Encoding: quoted-printable.\r\n\r\n".$message."\r\n\r\n".$attachment;*/
				
			else
				$message .= $attachment;
		}
		$mail_result = _ISI_SMTPMAIL($to_array, $subject, $message, $mime . $headers, $ccmail_array, $bccmail_array);
	}
		

	// Everything go smoothly?
	return $mail_result;
}


/**
 * unhtmlize string
 *
 * string
 */
function _ISI_UNHTMLENTITIES($string) {
	$trans_tbl = get_html_translation_table (HTML_ENTITIES);
	$trans_tbl = array_flip ($trans_tbl);
	$trans_tbl['&#039;'] = "'";
	return strtr ($string, $trans_tbl);
}

/**
 * send an email via SMTP
 *
 * return string if error, true if ok
 */
function _ISI_SMTPMAIL($mail_to_array, $subject, $message, $headers, $cc_array = null, $bcc_array = null) {
	global $inetd;

	if (!$socket = @fsockopen($inetd['smtp_server'], 25, $errno, $errstr, 20))
		return("Could not connect to smtp server : $errno : $errstr");

	if (!_ISI_STMPSERVERPARSE($socket, '220'))
		return false;
	if ($inetd['smtp_username'] != '' && $inetd['smtp_password'] != '')	{
		fputs($socket, 'HELO ' . $inetd['smtp_server'] . "\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '250'))
			return false;
		fputs($socket, "AUTH LOGIN\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '334'))
			return false;
		fputs($socket, base64_encode($inetd['smtp_username']) . "\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '334'))
			return false;
		fputs($socket, base64_encode($inetd['smtp_password']) . "\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '235'))
			return false;
	}
	else
	{
		fputs($socket, 'HELO ' . $inetd['smtp_server'] . "\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '250'))
			return false;
	}

	foreach ($mail_to_array as $mail_to)
	{
		fputs($socket, 'MAIL FROM: <' . $inetd["webmaster_mail"] . '>'."\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '250'))
			return false;
		fputs($socket, 'RCPT TO: <' . $mail_to . '>'."\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '250'))
			return false;
		if ($cc_array != null) {
			foreach ($cc_array as $cc) {
				fputs($socket, 'RCPT TO: <' . $cc . '>'."\r\n");
				if (!_ISI_STMPSERVERPARSE($socket, '250'))
					return false;
			}
		}
		if ($bcc_array != null) {
			foreach ($bcc_array as $bcc) {
				fputs($socket, 'RCPT TO: <' . $bcc . '>'."\r\n");
				if (!_ISI_STMPSERVERPARSE($socket, '250'))
					return false;
			}
		}
		fputs($socket, "DATA\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '354'))
			return false;
		fputs($socket, 'Subject: ' . $subject . "\r\n");
		if (strlen($mail_to))
			fputs($socket, 'To: <' . $mail_to . '>'."\r\n");
		fputs($socket, $headers . "\r\n\r\n");
		fputs($socket, $message . "\r\n");
		fputs($socket, ".\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '250'))
			return false;
		fputs($socket, "RSET\r\n");
		if (!_ISI_STMPSERVERPARSE($socket, '250'))
			return false;
	}
	fputs($socket, "QUIT\r\n");
	fclose($socket);

	return true;
}

/**
 * parse a message to the SMTP server
 *
 * return false if errors, true if ok
 */
function _ISI_STMPSERVERPARSE($socket, $response) {
	// No response yet.
	$server_response = '';

	while (substr($server_response, 3, 1) != ' ')
		if (!($server_response = fgets($socket, 256))) {
			//echo 'Couldn\'t get mail server response codes';
			return false;
		}

	if (substr($server_response, 0, 3) != $response) {
		//echo 'Problems in sending Mail. Error: '.$server_response;
		return false;
	}

	return true;
}

/**
 * check for errors in a GET
 * create a notfound page on errors
 * return false if there is not GET further than GETpage
 * return true if GET is valid
 *
 * boolean
 */
function _ISI_ISGETVALID($baseaction, $available_actions_array) {
	global $inetd;
	$match = false; $fakeaction = false;
	foreach ($_GET as $key => $value) {
		if ($key != $inetd["GETpage"] && $key != $baseaction) $fakeaction = true;					
		if ($key == $baseaction && in_array($value, $available_actions_array)) $match = true;
	}
	if (!$match) {
		if ($fakeaction) _ISI_NOTFOUND();
		elseif ($_GET[$baseaction] == null) return false;
		else _ISI_NOTFOUND();
	}
	else return true;
}







/**
 * drivers function exec routine
 *
 * for each driver call a function
 *
 * return an array
 *  $array[0][0] = drivername
 *  $array[0][1] = execution signal (true, false)
 *  $array[0][2] = driver function return (if exec was true returns a value, else return error code/string)
 */
function _ISI_DRIVERS($function, $indrivers = null, $params = null) {
	global $inetd, $drivers_already_instanced;
	if ($drivers_already_instanced == null) $drivers_already_instanced = array(); 
	$signal = array(); 
	if ($indrivers != null) $drivers = $indrivers;
	else $drivers = $inetd["drivers"];
	for ($i = 0; $i < count($drivers); $i++) {
		//if (function_exists($driver.$function)) { //PROCEDURALE
		$instance = null; $already_instanced = false;
		for ($n = 0; $n < count($drivers_already_instanced); $n++) {
			if ($drivers[$i] == get_class($drivers_already_instanced[$n])) {
				$already_instanced = true;
				$instance = $drivers_already_instanced[$n];
				break;
			}
		}
		if (!$already_instanced) {
			$instance = new $drivers[$i];
			$driver_already_instanced = array_push($drivers_already_instanced, $instance);
		}
		//echo $drivers[$i].'|'.get_class($instance).'->'.$function.'<br />';
		if (method_exists($instance, $function)) {
			//$tmpsignal = call_user_func_array($instance->$function, $params);//PROCEDURALE
			$tmpsignal = $instance->$function($params);
			$signal[0][0] = $drivers[$i];
			$signal[0][1] = $tmpsignal[0];
			$signal[0][2] = $tmpsignal[1];
			if ($signal[0][1] == false) {
				return $signal;
			}
		}
	}
	return $signal;
}

/**
 * user complete signup routine
 *
 * string if errors
 */
function _ISI_SIGNUP($driversarray = null) {
	global $inetd;
	$done = true;
	if ($driversarray == null) $drivers = array($inetd["drivers"][0]);
	else $drivers = $driversarray;
	$return = _ISI_DRIVERS('_ISI_CREATEUSER_VERIFY', $drivers);
	//print_r($return);
	$errors = false;
	for ($i = 0; $i < count($return); $i++) {
		if ($return[$i][1] == false) {
			$i = count($return);
			$errors = true;
		}
	}
	if ($errors == false)
		$return = _ISI_DRIVERS('_ISI_CREATEUSER', $drivers);

	return $return;
}

/**
 * user complete signout (delete) routine
 *
 * string if errors
 */
function _ISI_SIGNOUT($in_id) {
	global $inetd;
	$done = true;
	$return = _ISI_DRIVERS('_ISI_DELETEUSER_VERIFY', null, array($in_id));
	$errors = false;
	for ($i = 0; $i < count($return); $i++) {
		if ($return[$i][1] == false) {
			$i = count($return);
			$errors = true;
		}
	}
	if ($errors == false)
		$return = _ISI_DRIVERS('_ISI_DELETEUSER', null, array($in_id));

	return $return;
}

/**
 * user partial (isicms driver) creation routine
 *
 * string if errors
 */
function _ISI_CREATEUSER($username, $password, $email = null, $group = null, $groupsid = null, $enableuser = false) {
	global $inetd;
	$done = true;
	$return = _ISI_DRIVERS('_ISI_CREATEUSER_VERIFY', array($inetd["drivers"][0]), array($username, $password, $email, $group));
	$errors = false;
	if ($return[0][1] == false) $errors = true;
	if ($errors == false) $return = _ISI_DRIVERS('_ISI_CREATEUSER', array($inetd["drivers"][0]), array($username, $password, $email, $group, $groupsid, $enableuser));
	return $return;
}

/**
 * password change function
 *
 * void
 */
function _ISI_CHPASS($in_id, $in_user, $newpass) {
	global $inetd;
	return _ISI_DRIVERS('_ISI_CHPASS', array($inetd["drivers"][0]), array($in_id, $in_user, $newpass));
}

/**
 * password change function with check on old password
 *
 * boolean
 */
function _ISI_CHPASS_WITHCHECKOLDPASS($in_id, $in_user, $oldpass, $newpass) {
	global $inetd;
	return _ISI_DRIVERS('_ISI_CHPASS_WITHCHECKOLDPASS', array($inetd["drivers"][0]), array($in_id, $in_user, $oldpass, $newpass));
}

/**
 * email change function
 *
 * void
 */
function _ISI_CHEMAIL($in_id, $inemail) {
	global $inetd;
	return _ISI_DRIVERS('_ISI_CHEMAIL', array($inetd["drivers"][0]), array($in_id, $inemail));
}

/**
 * create random password for user
 * 
 * string
 */
function _ISI_CREATE_RDMPASS($in_user) {
	global $inetd;
	$return = _ISI_DRIVERS('_ISI_CREATE_RDMPASS', array($inetd["drivers"][0]), array($in_user));
	return $return;
}


/**
 * send password mail to a user
 * 
 * void
 */
function _ISI_SEND_PASSMAIL($mail, $user, $password) {
	global $inetd;
	_ISI_DRIVERS('_ISI_SEND_PASSMAIL', array($inetd["drivers"][0]), array($mail, $user, $password));
}


/**
 * session controller
 *
 * void
 */
 function _ISI_SESSION($writelog = 1) {
	global $inetd, $id_user, $userinfo, $authtype;

	session_start();
	$session = session_id();

	if ($authtype == 'cookie')
		$return = _ISI_DRIVERS('_ISI_IDUSER_FROMCOOKIE', array($inetd["drivers"][0]));
	elseif ($authtype == 'session')
		$return = _ISI_DRIVERS('_ISI_IDUSER_FROMSESSION', array($inetd["drivers"][0]));
	else
		$return = _ISI_DRIVERS('_ISI_IDUSER_FROMSESSION', array($inetd["drivers"][0]));

	$id_user = $return[0][2];

	if ($id_user != "Guest") {
		$tmp = _ISI_DRIVERS('_ISI_GETUSER_AUTHINFO', array($inetd["drivers"][0]), array($id_user));
  		$tmpuserinfo = $tmp[0][2];
  		$userinfo["username"] = $tmpuserinfo[0][0];
  		$userinfo["userfake"] = $tmpuserinfo[0][1];
  		$userinfo["usergroup"] = $tmpuserinfo[0][2];
  		$userinfo["usermail"] = $tmpuserinfo[0][3];
  		$reply = _ISI_DBQUERY("SELECT firstLogin FROM ".$inetd["dbprefix"]."members 
							WHERE ID_MEMBER = '".$id_user."'");
		$userinfo["firstLogin"] = $reply[0][0];
  		/* inizializza i gruppi di cui l'utente fa parte */
  		_ISI_INITUSERGROUPS();
 	}
 	if ($writelog == 1) _ISI_DRIVERS('_ISI_WRITELOG', array($inetd["drivers"][0]), array($id_user));
}

/**
 * login function
 *
 * void
 */
 function _ISI_LOGIN() {
	global $inetd, $id_user, $modrequest, $userinfo, $_SESSION;
	$in_user = $_POST[$inetd["form_user"]];
	$in_pass = $_POST[$inetd["form_pass"]];
	$tmp = _ISI_DRIVERS('_ISI_VALIDATEUSER', array($inetd["drivers"][0]), array($in_user, $in_pass));
	$isvalid = $tmp[0][2];

	if ($isvalid) {
		$in_iduser = _ISI_GETIDUSER_FROMUSERNAME($in_user);
	
		$logingroup = false;
		if ($inetd["logingroups"] != null) {
			if ($inetd["logingroups"] == false) {
				$logingroup = false;
			}
			else {
				$validgroups = explode(" ", $inetd["logingroups"]);
				for ($x = 0; $x < count($validgroups); $x++) {					
					if (_ISI_ISINGROUP($validgroups[$x], $in_iduser)) $logingroup = true;
				}
			}
		} else $logingroup = true;

		if ($logingroup) {
			// force logout of older sessions
		  	$result = _ISI_DRIVERS('_ISI_GETSESSION', array($inetd["drivers"][0]), array($in_iduser));
		  	//print_r($result);
		  	if ($result[0][2] != null && trim($result[0][2]) != '') {
		  		// if this user is part of "sessiongroups" then print for a "already logged in page"
		  		if ((preg_match("/".$in_iduser.",/i", $inetd["sessiongroups"]))) {
	  				if ($in_iduser != null) {
						$id_user = "Guest";
			  			$userinfo["username"] = null;
			  			$userinfo["userfake"] = null;
			  			$userinfo["usergroup"] = null;
			  			$userinfo["usermail"] = null;
			  			header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'=AlreadyLogged');
			  			#break;
		  			}
	  			}
		  		else {
					//echo session_save_path().'/sess_'.$result[0][2];
					//exit(0);
					$oldsessid = $result[0][2];		 		
					@session_start($oldsessid);
					$reply = _ISI_DBQUERY("SELECT firstLogin FROM ".$inetd["dbprefix"]."members
											WHERE ID_MEMBER = '".$in_iduser."'");
					if ( ($reply[0][0] > 0) && ($in_iduser != 1) ) {
						_ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."members
										SET passwd = '' WHERE ID_MEMBER = '".$in_iduser."'");
					}
		  			_ISI_DBQUERY("DELETE FROM ".$inetd["dbprefix"]."log_online WHERE identity='".$in_iduser."'");
					_ISI_DRIVERS('_ISI_CLEARSESSION',array($inetd["drivers"][0]), array($in_iduser));
					_ISI_DRIVERS('_ISI_CLEARAUTHDATA',array($inetd["drivers"][0]));
					@session_destroy();
					@unlink(session_save_path().'/sess_'.$result[0][2]);
		  		}
		  	}
			session_start();
			$id_session = session_id();
			$id_user = $in_iduser;
			
		  	_ISI_DRIVERS('_ISI_WRITELOG', array($inetd["drivers"][0]), array($in_user));
			_ISI_DRIVERS('_ISI_SETSESSION', array($inetd["drivers"][0]), array($in_user, $id_session));
			_ISI_DRIVERS('_ISI_SETAUTHDATA', array($inetd["drivers"][0]), array($in_user, $in_pass));
			
			_ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."members 
						SET loginAttempts = '0' WHERE ID_MEMBER = '".$id_user."'");
			
			if (isset($_POST[$inetd["form_referer"]]))
				header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'='.$_POST[$inetd["form_referer"]]);
			else {
				if ($modrequest != null) header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'='.$_GET["page"]);
				header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'=User');
	  		}
		}
		else header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'=AuthErr');
	}
	else {
		$attempts = 0;
		$reply = _ISI_DBQUERY("SELECT ID_MEMBER FROM ".$inetd["dbprefix"]."members 
							WHERE memberName = '".$in_user."'");
		$breaker_id = $reply[0][0];
		if ($breaker_id != 1) {
			if ($reply[0][0] != null) {
				$reply = _ISI_DBQUERY("SELECT loginAttempts FROM ".$inetd["dbprefix"]."members 
								WHERE ID_MEMBER = '".$breaker_id."'");
				$attempts = $reply[0][0] + 1;
				_ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."members 
					SET loginAttempts = '".$attempts."' WHERE ID_MEMBER = '".$breaker_id."'");
			}
		}
		if ($attempts > 5) {
			_ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."members 
				SET passwd = '' WHERE ID_MEMBER = '".$breaker_id."'");
			header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'=AccountDisabled');
		}
		else {
			if (isset($_POST[$inetd["form_referer_err"]]))
				header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'='.$_POST[$inetd["form_referer_err"]]);
			else
				header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'=AuthErr');
		}
	}
	//break;
}

/**
 * return default layout based on url
 * 
 * string
 */
function _ISI_GETLAYOUT_FROMURL() {
	global $_SERVER, $inetd;
	if ($inetd["hosttemplate"]) {
		$httphost = $_SERVER["HTTP_HOST"];
		for ($i = 0; $i < count($inetd["host"]); $i++) {
			if ($httphost == $inetd["host"][$i] && isset($inetd["layout"][$i])) {
				return $inetd["layout"][$i];
			}
		}
	}
	return null;
}


/**
 * logout function
 *
 * void
 */
function _ISI_LOGOUT() {
	global $inetd, $id_user, $authtype, $_SESSION, $defaultlayout, $userinfo;
	//echo $layout;
	if ($authtype = 'cookie')
		$return = _ISI_DRIVERS('_ISI_IDUSER_FROMCOOKIE', array($inetd["drivers"][0]));
	elseif ($authtype = 'session')
		$return = _ISI_DRIVERS('_ISI_IDUSER_FROMSESSION', array($inetd["drivers"][0]));
	else
		$return = _ISI_DRIVERS('_ISI_IDUSER_FROMSESSION', array($inetd["drivers"][0]));
	
	$id_user = $return[0][2];
	_ISI_DEBUG($id_user);
	_ISI_DRIVERS('_ISI_WRITELOG', array($inetd["drivers"][0]), $id_user);
	_ISI_SETLAYOUT(_ISI_GETLAYOUT_FROMURL());
	if ($id_user != "Guest") {
		$reply = _ISI_DBQUERY("SELECT firstLogin FROM ".$inetd["dbprefix"]."members 
								WHERE ID_MEMBER = '".$id_user."'");
		if ( ($reply[0][0] > 0) && ($in_iduser != 1) ) {
			_ISI_DBQUERY("UPDATE ".$inetd["dbprefix"]."members 
							SET passwd = '' WHERE ID_MEMBER = '".$id_user."'");
		}
		_ISI_DBQUERY("DELETE FROM ".$inetd["dbprefix"]."log_online WHERE identity='".$id_user."'");
		_ISI_DRIVERS('_ISI_CLEARSESSION',array($inetd["drivers"][0]), array($id_user));
		_ISI_DRIVERS('_ISI_CLEARAUTHDATA',array($inetd["drivers"][0]));
		@session_destroy();
		header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'=Logout');
	}
	else {
		@session_destroy();
		header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'=LogoutExpire');
	}
	$id_user = "Guest";
}

/**
 * set user global layout
 *
 * void
 */
function _ISI_SETLAYOUT($in_layout) {
	global $locklayout, $inetd, $defaulttemplate, $template, $modrequest, $layout;
	if (!$locklayout) {
		$templatepage = is_file($inetd["templatepath"].'/'.$in_layout.'/'.$template.'.php');
		$defaultpage = is_file($inetd["templatepath"].'/'.$in_layout.'/'.$defaulttemplate.'.php');		
		if ($templatepage) {
			$cookielayout = $in_layout;
		 	$layout = $in_layout;
		}
		elseif ($defaultpage) {
			$cookielayout = $in_layout;
		 	$layout = $in_layout;
			$template = $defaulttemplate;
		}
		else {
			$cookielayout = '';
		}
		//echo $layout;
		_ISI_DRIVERS('_ISI_SETLAYOUT_COOKIE', array($inetd["drivers"][0]), array($cookielayout));
	}
	if ($_GET[$inetd["GETpage"]] != "")	header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'='.$modrequest.$inetd["furtherurl"]);
	else header('Location: '.$inetd["url"].'/index.php');
}

/**
 * layout management
 *
 * return a string
 */
function _ISI_LAYOUT() {
	global $locklayout, $inetd, $template, $style, $layout, $defaulttemplate;
	if (!$locklayout) {
		$tmp = _ISI_DRIVERS('_ISI_GETLAYOUT_FROMCOOKIE', array($inetd["drivers"][0]));
		$tmplayout = $tmp[0][2];
		$templatepage = is_file($inetd["templatepath"].'/'.$tmplayout.'/'.$template.'.php');
		$defaultpage = is_file($inetd["templatepath"].'/'.$tmplayout.'/'.$defaulttemplate.'.php');		
		
		if ($templatepage) {
			$layout = $tmplayout;
		 	$inetd["imgpath"] = $inetd["imgorigpath"].'/'.$layout;
		 	_ISI_POSTCONF();
		}
		elseif ($defaultpage) {
			$layout = $tmplayout;
		 	$inetd["imgpath"] = $inetd["imgorigpath"].'/'.$layout;
		 	$template = $defaulttemplate;
		 	_ISI_POSTCONF();
		}
	}
}

/**
 * set user global locale
 *
 * void
 */
function _ISI_SETLOCALE($in_locale) {
	global $inetd, $locale, $modrequest, $id_user;
	$locale = $in_locale;
	_ISI_DRIVERS('_ISI_SETLOCALE_COOKIE', array($inetd["drivers"][0]), array($locale));
	if ($id_user != 'Guest') _ISI_DRIVERS('_ISI_SETLOCALE_DB', array($inetd["drivers"][0]), array($locale));
		if ($_GET["page"] != "")
			header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'='.$modrequest.$inetd["furtherurl"]);
		else
			header('Location: '.$inetd["url"].'/index.php');
}

/**
 * locale management
 *
 * return locale string
 */
function _ISI_LOCALE() {
	 global $inetd, $locale, $layout;
	 $defaultlocale = $locale;
	 if (is_file($inetd["templatepath"].'/'.$layout.'/conf.php')) {
	 	include ($inetd["templatepath"].'/'.$layout.'/conf.php');
	 	$tmplocale = $inetd["locale"][0];
		if (isset($tmplocale)) $locale = $tmplocale;
	 }
	$tmp = _ISI_DRIVERS('_ISI_GETLOCALE_FROMCOOKIE', array($inetd["drivers"][0]));
	$tmplocale = $tmp[0][2];

	for ($i = 0; $i < count($inetd["locale"]); $i++) {
		if ($inetd["locale"][$i] == $tmplocale) {
			$found = true;
		 	$i = count($inetd["locale"]);
		 }
	}
	if (isset($tmplocale) && $found) {
	 	$locale = $tmplocale;
	}
	else $locale = $defaultlocale;
  	/* carica tutti i gruppi nella var d'ambiente $groups */
  	_ISI_LOADGROUPS();
	return $locale;
}

/**
 * set user template
 *
 * void
 */
function _ISI_SETTEMPLATE($in_template) {
	global $locktemplate, $inetd, $template, $modrequest, $layout;
	if (!$locktemplate) {
		if (is_file($inetd["templatepath"].'/'.$layout.'/'.$in_template.'.php')) {
			$template = $in_template;
		}
		_ISI_DRIVERS('_ISI_SETTEMPLATE_COOKIE', array($inetd["drivers"][0]), array($template));
	}
	if ($_GET[$inetd["GETpage"]] != "")
		header('Location: '.$inetd["url"].'/index.php?'.$inetd["GETpage"].'='.$modrequest.$inetd["furtherurl"]);
	else
		header('Location: '.$inetd["url"].'/index.php');
}

/**
 * template management
 *
 * return template as string
 */
function _ISI_TEMPLATE() {
	global $locktemplate, $inetd, $template, $style, $layout;
	if (!$locktemplate) {
		$tmp = _ISI_DRIVERS('_ISI_GETTEMPLATE_FROMCOOKIE', array($inetd["drivers"][0]));
		$tmptemplate = $tmp[0][2];
		if (is_file($inetd["templatepath"].'/'.$layout.'/'.$tmptemplate.'.php')) {
			$template = $tmptemplate;
		}
	}
	return $template;
}


# get colored fakename from id (or username if no fakename is set)
#
# string
function _ISI_GETFAKE($in_id = null) {
 global $inetd, $id_user;
 if (!isset($in_id))
 $in_id = $id_user;
 $reply = _ISI_DBQUERY("SELECT memberName, realName FROM ".$inetd["dbprefix"]."members
							WHERE ID_MEMBER='".$in_id."'");
 if (isset($reply[0][1]) && $reply[0][1] != "")
 return _ISI_COLORFAKE($reply[0][1]);
 else
 return $reply[0][0];
}

# fakename change
#
# void
function _ISI_CHANGEFAKE($new_fake) {
	global $userinfo, $id_user, $inetd;
	$allspaces = true; $allcolor = false;
	for ($i = 0; $i < strlen($new_fake); $i++) {
		if ($new_fake[$i] == "^") {
			$i++;
			$allcolor = true;
			$allspaces = false;
		}
		else {
			if ($new_fake[$i] != " ") {
				$allcolor = false;
				$allspaces = false;
				$i = strlen($new_fake);
			}
		}
	}
	if (!$inetd["usefake"]) {
		$fake = _ISI_DBQUERY("SELECT realName FROM {$inetd["dbprefix"]}members
								WHERE memberName = '".$userinfo["username"]."'");
		if ($fake[0][0] != null && !$allspaces && !$allcolor) $new_fake = $fake[0][0];
			else $new_fake = $userinfo["username"];
	}
	else {
		if ($allspaces || $allcolor) {
			$new_fake = $userinfo["username"];
		}
	}
	$new_fake = str_replace("\"", "'", $new_fake);
	$new_fake = _ISI_MYESCAPE ($new_fake);
	$new_fake = str_replace("<", "< ", $new_fake);
	$new_fake = str_replace(">", " >", $new_fake);
	$new_fake = str_replace("--", "-", $new_fake);
	$new_fake = str_replace("--", "-", $new_fake);
	$new_fake = str_replace("--", "-", $new_fake);
	_ISI_DBQUERY ("UPDATE ".$inetd["dbprefix"]."members
				SET realName = '".$new_fake."', im_ignore_list = NULL WHERE ID_MEMBER =".$id_user);
}

function _ISI_URLEXISTS($url){
	$stream = @get_headers($url);
	if (preg_match("|200|", $stream[0])) return true;
	else return false;
}


function _ISI_LICENSED() {
	global $inetd, $id_user, $userlib;
	if (($inetd["license"] == true) && ($id_user != "Guest"))
		if ($userlib->userAcceptedLicense())
			return true;
		else
			return false;
	else
		return true;
}
?>
