<?php


### boot check
global $id_user;
if (!$id_user) {
	echo $modname . ": boot missing";
	exit (1);
}

# print colored string
#
# string
function _ISI_COLORFAKE($instr = null, $colored = null) {
	global $inetd, $userinfo;
	if ($inetd["usefake"]) {
		if ($instr == null)
			$instr = $userinfo["userfake"];
		if ($colored != null) {
			if ($colored)
				return ('<script language="JavaScript">SubmitNickPrint("' . $instr . '")</script>');
			else
				return ('<script language="JavaScript">SubmitNickPrintNoColor("' . $instr . '")</script>');
		} else {
			if ($inetd["colorfake"])
				return ('<script language="JavaScript">SubmitNickPrint("' . $instr . '")</script>');
			else
				return ('<script language="JavaScript">SubmitNickPrintNoColor("' . $instr . '")</script>');
		}
	} else {
		if ($instr == null)
			$instr = $userinfo["username"];
		return ($instr);
	}
}

# return html to create tooltip
#
# html
function _ISI_TOOLTIP($inalt, $body, $divstyle = null) {
	global $inetd;
	if ($divstyle != null)
		$style = 'class="' . $divstyle . '"';
	$alt = preg_replace("/\"/", "\'", $inalt);
	$out = '<span ' . $style . ' onmouseover="return escape(\'';
	$out .= "<table cellpadding=\'0\' cellspacing=\'0\' style=\'background-color: transparent;\'><tr>";
	$out .= "<td height=\'7px\' style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_topsx.gif); background-repeat: no-repeat;\'></td>";
	$out .= "<td style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_top.gif); background-repeat: repeat-x;\'></td>";
	$out .= "<td style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_topdx.gif); background-repeat: no-repeat;\'></td></tr><tr>";
	$out .= "<td width=\'7px\' style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_sx.gif); background-repeat: repeat-y;\'></td>";
	$out .= "<td style=\'background:black; color:white;\'>" . $alt . "</td>";
	$out .= "<td width=\'7px\' style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_dx.gif); background-repeat: repeat-y;\'></td></tr><tr>";
	$out .= "<td height=\'7px\' style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_bottomsx.gif); background-repeat: no-repeat;\'></td>";
	$out .= "<td style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_bottom.gif); background-repeat: repeat-x;\'></td>";
	$out .= "<td style=\'background-image: url(" . $inetd["imgorigpath"] . "/isicms/styles/badgeblack_bottomdx.gif); background-repeat: no-repeat;\'></td></tr></table>";
	$out .= '\')" >';
	$out .= $body . '</span>';
	return $out;
}

# return a collapse based menu
# styles needed are:
# $styles["tablehead_title"]
# $styles["tablehead_notitle"]
# $styles["tablebody"]
# $styles["div"]
#
# html
function _ISI_COLLAPSE($menuname, $title, $styles, $foldimg, $expimg, $body) {
	global $_COOKIE;
	$cpostfix = "-CONTENT";
	$cid = $menuname . $cpostfix;
	if ($_COOKIE["box-" . $cid] == "folded") {
		$folded = "folded";
		$foldedimg = $expimg;
	} else {
		$folded = "unfolded";
		$foldedimg = $foldimg;
	}

	$html = '
	<table class="' . $styles["tablehead_title"] . '">
		<tr>
			<td class="' . $styles["tablehead_title"] . '">
				<div class="' . $styles["div"] . '">' . $title . '</div>
			</td>
			<td class="' . $styles["tablehead_notitle"] . '">
				<div class="' . $styles["div"] . '">
					<img src="' . $foldedimg . '"
						id="icon-' . $cid . '" vspace="0" hspace="0"
						alt="Collapse and Expand Menu" title="Collapse and Expand Menu"
						onclick="toggleMiniframe(\'' . $cid . '\',\'' . $expimg . '\',\'' . $foldimg . '\')" />
				</div>
			</td>
		</tr>
	</table>
	<div id="box-' . $cid . '" class="' . $folded . '">
		<table class="' . $styles["tablebody"] . '">
			<tr><td class="' . $styles["tablebody"] . '">
				' . $body . '
			</td></tr>
		</table>
	</div>';

	return $html;
}

# print a generic img/txt choice menu (1st parm is "img" or a generic text that will use a "span")
#
# html
function _ISI_COLLAPSEMENU($type, $name, $foldimg, $expimg, $body, $style = null, $in_distance = 10, $in_vertdist = 0, $keepopen = false) {
	global $inetd, $locale, $modrequest;
	if ($inetd["client_brow"] == "ie") {
		$distance = $in_distance -20;
		$vert_dist = $in_vertdist +15;
	}
	elseif ($inetd["client_brow"] == "opera") {
		$distance = $in_distance -5;
		$vert_dist = $in_vertdist +5;
	} else {
		$distance = $in_distance;
		$vert_dist = $in_vertdist;
	}
	if ($type != "img") {
		$txt = $type;
		$type = "span";
	}
	$html = '
			<' . $type . ' style="cursor:pointer;" class="' . $style . '" src="' . $foldimg . '"
				id="icon-' . $name . '-CONTENT" vspace="0" hspace="0"
				alt="Collapse and Expand ' . $name . ' choice menu" title="Collapse and Expand ' . $name . ' choice menu"';

	$html .= '
				onclick="toggleFrame(\'' . $name . '-CONTENT\',
					\'' . $foldimg . '\',
					\'' . $expimg . '\')">';
	if ($type != "img")
		$html .= $txt;

	$html .= '</' . $type . '>
			<div id="box-' . $name . '-CONTENT"';
			
	if ($keepopen == false)
		$html .= '
			onmouseout="closeFrame(\'' . $name . '-CONTENT\', \'' . $foldimg . '\', \'' . $expimg . '\')""
			onmouseover="keepFrame(\'' . $name . '-CONTENT\', \'' . $foldimg . '\', \'' . $expimg . '\')"';
			
	$html .= '
			class="def_collapse_style"
			style="z-index: 1000; position:absolute; margin-top:' . $vert_dist . 'px; margin-left:' . $distance . 'px; -moz-margin-start:+' . $distance . 'px; display: none;">';
	$html .= $body;
	$html .= '</div>';
	return $html;
}

# print indexes (to use with startfrom=X as GET)
#
# html
function _ISI_INDEXES($link, $start, $inindex, $total, $contiguous = null, $cssindex = null) {
	$maxindex = $inindex;
	if ($contiguous != "") $PageContiguous = $contiguous;
	else $PageContiguous = 2;

	$css = $cssindex != null ? ' id="'.$cssindex.'" ' : 'id="numberlist"';
	
	if (!isset ($start))
		$start = 0;
	if ($start > $total)
		$start = ($total % $maxindex) * $maxindex;
	elseif ($start < 0) $start = 0;
	$start = (int) ($start / $maxindex) * $maxindex;

	if ($start > $maxindex * $PageContiguous) //first
		$pageindex .= '<a '.$css.' href="' . $link . '&amp;startfrom=0">1</a> ';
	if ($start > $maxindex * ($PageContiguous +1)) // ...
		$pageindex .= '<span style="font-weight: bold"> ... </span>';

	for ($nCont = $PageContiguous; $nCont >= 1; $nCont--) // 1 & 2 before
		if ($start >= $maxindex * $nCont) {
			$tmpStart = $start - $maxindex * $nCont;
			$tmpPage = $tmpStart / $maxindex +1;
			$pageindex .= '<a '.$css.' href="' . $link . '&amp;startfrom=' . $tmpStart . '">' . $tmpPage . '</a> ';
		}

	$tmpPage = $start / $maxindex +1; // page to show
	$pageindex .= '<span '.$css.' style="font-weight: bold">['.$tmpPage.']</span> ';
	
	$tmpMaxPages = (int) (($total -1) / $maxindex) * $maxindex; // 1 & 2 after

	for ($nCont = 1; $nCont <= $PageContiguous; $nCont++)
		if ($start + $maxindex * $nCont <= $tmpMaxPages) {
			$tmpStart = $start + $maxindex * $nCont;
			$tmpPage = $tmpStart / $maxindex +1;
			$pageindex .= '<a '.$css.' href="' . $link . '&amp;startfrom=' . $tmpStart . '">' . $tmpPage . '</a> ';
		}

	if ($start + $maxindex * ($PageContiguous +1) < $tmpMaxPages) // ...
		$pageindex .= '<span style="font-weight: bold"> ... </span>';

	if ($start + $maxindex * $PageContiguous < $tmpMaxPages) { // last
		$tmpPage = $tmpMaxPages / $maxindex +1;
		$pageindex .= '<a '.$css.' href="' . $link . '&amp;startfrom=' . $tmpMaxPages . '">' . $tmpPage . '</a> ';
	}

	return $pageindex;
}

function _ISI_FONTSTRUMENTS() {
	global $inetd;
	print ('<span><a onclick="setActiveStyleSheet(\'font_small\'); return false;"
			title="small text" href="#" style="text-decoration: none;"><img
				border="0" src="' . $inetd["imgpath"] . '/navmenu/font_small.gif"></a>&nbsp;<a
			onclick="setActiveStyleSheet(\'font_normal\'); return false;"
			title="normal text" href="#" style="text-decoration: none;"><img
				border="0" src="' . $inetd["imgpath"] . '/navmenu/font_normal.gif"></a>&nbsp;<a
			onclick="setActiveStyleSheet(\'font_big\'); return false;" title="big text" href="#"
			style="text-decoration: none;"><img
				border="0" src="' . $inetd["imgpath"] . '/navmenu/font_big.gif"></a></span>');
}

function _ISI_DECREASEFAKE($fake, $decrease_nick = 10) {
	$leng = strlen($fake);
	$count = 0;
	for ($x = 0; $x < $leng; $x++) {
		if (substr($fake, $x, 1) == '^') {
			if ($x < ($decrease_nick + $count))
				$count += 2;
		}
	}
	if ($count > 1)
		$decrease_nick = $decrease_nick + $count;

	if (strlen($fake) > $decrease_nick) {
		$fake = substr($fake, 0, $decrease_nick) . "..";
	}

	return($fake);
}

function _ISI_BS_INPUTCALENDAR($style, $format) {
	print('
        <script type="text/javascript">
            $(function () {
                $("#'.$style.'").datetimepicker({
                    format: "'.$format.'"
                });
            });
        </script>
			');
}
?>
