<?php

### configurazioni e controllo boot
//include_once ('conf.php');
global $id_user; if (!$id_user) {echo $modname.": boot missing"; exit(1);}

global $inetd, $isadmin, $adminlogged, $locale, $template, $layout, $html, $modrequest,
$modname, $modlocale, $modtemplate, $content, $modpage, $side;

if ($inetd["print_modname"] == 1 && $inetd["action"] != "header")
echo $locale.'/'.$side.'.'.$modname.'-'.$modtemplate.'/'.$modpage.'|';

# se c'e' il locale carica la lingua del modulo // language loader
$tmplocale = (($modlocale != null) && ($modlocale != ''))? $modlocale : $locale;
$finalocale = (($locale != null) && ($locale != ''))? $locale : $tmplocale;

# patch per riuscire ad includere l'html in /include/ e il template usando il locale giusto
$withlocale = false;
if ($modname == 'include') {
 if (is_file($inetd["includepath"].'/'.$layout.'/locale/'.$finalocale.'.php') && ($modpage == null)) {
 	include($inetd["includepath"].'/'.$layout.'/locale/'.$finalocale.'.php');
 }
 else {
  if (is_file($inetd["includepath"].'/'.$layout.'/locale/'.$finalocale.'/'.$modpage.'.php')) {
  	include($inetd["includepath"].'/'.$layout.'/locale/'.$finalocale.'/'.$modpage.'.php');
   $withlocale = true;
  }
  if (is_file($inetd["includepath"].'/'.$layout.'/'.$modpage.'.php'))
  include($inetd["includepath"].'/'.$layout.'/'.$modpage.'.php');
  else
  if (!$withlocale) _ISI_NOTFOUND();
 }
}
#

else {
	# carica la lib.php solo se non e' ancora stata inclusa
	# -> stratagemma per richiedere la lib del modulo
	$libtoload = true; $i = 0;
	if ($mods[0] == null) $mods[0] = $modname;
	else {
		for ($i=0;$i<count($mods);$i++)
		if ($mods[$i] == $modname) {
			$libtoload = false; $i = count($mods);
		}
	}

	if ($libtoload) {
		$mods[$i] = $modname;
		if (is_file($inetd["modpath"].'/'.$modname.'/conf.php'))
		require_once($inetd["modpath"].'/'.$modname.'/conf.php');
		if (is_file($inetd["modpath"].'/'.$modname.'/lib.php'))
		require_once($inetd["modpath"].'/'.$modname.'/lib.php');
	}

	# carica il locale del modulo
	if (is_file($inetd["modpath"].'/'.$modname.'/locale/'.$finalocale.'.php')) {
		include($inetd["modpath"].'/'.$modname.'/locale/'.$finalocale.'.php');
		if (is_file($inetd["modpath"].'/'.$modname.'/locale/'.$finalocale.'/'.$modpage.'.php'))
		include($inetd["modpath"].'/'.$modname.'/locale/'.$finalocale.'/'.$modpage.'.php');
	}
	#

	# require solo la pagina html necessaria (usando il nome file $modpage)
	# per le varie directory admin, user e public a seconda della tipologia di visitatore.
	# in ultimo attacca, se esiste, un template specificato, in modo che quest'ultimo abbia tutte le informazioni necessarie gia' caricate
	#
	# setta il template
	$localtemplate = ($modtemplate != null)? $modtemplate.'.php' : null;
	$userarea_notpresent = false;

	if ($id_user != 'Guest') { // logged user side
		$adminpage = is_file($inetd["modpath"].'/'.$modname.'/admin/'.$modpage.'.php');
		$modadmindir = is_dir($inetd["modpath"].'/'.$modrequest.'/admin/');

		if ($side == 2) { // always print admin side
			if ($isadmin && $adminpage && ($modadmindir || $modrequest == 'Admin')
			&& (_ISI_ISGLOBALADMIN() || _ISI_ISMODADMIN($modrequest)) ) {
				if (is_file($inetd["modpath"].'/'.$modname.'/admin/'.$modpage.'.php')) {
					require($inetd["modpath"].'/'.$modname.'/admin/'.$modpage.'.php');
					if (is_file($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate))
					include($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate);
				}
			}
		}

		elseif ($side == 1) { //print only user or public side
			if (is_file($inetd["modpath"].'/'.$modname.'/user/'.$modpage.'.php')) {
				require($inetd["modpath"].'/'.$modname.'/user/'.$modpage.'.php');
				if (is_file($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate))
				include($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate);
			} else _ISI_NOTFOUND();
		}

		elseif ($side == 0) { //force print of public side
			if (is_file($inetd["modpath"].'/'.$modname.'/public/'.$modpage.'.php')) {
				require($inetd["modpath"].'/'.$modname.'/public/'.$modpage.'.php');
				if (is_file($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate))
				include($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate);
			} else _ISI_NOTFOUND();
		}

		elseif ($side == -1) { //print admin only when requested, else user/public area
			if ($isadmin && $adminpage && ($modadmindir || $modrequest == 'Admin')
			&& (_ISI_ISGLOBALADMIN() || _ISI_ISMODADMIN($modrequest) )) { //is an admin

				if ( (_ISI_ISADMINLOGGED() && _ISI_ADMINISEDIT())	) { // admin logged and is editing
					if (is_file($inetd["modpath"].'/'.$modname.'/admin/'.$modpage.'.php')) {
						require($inetd["modpath"].'/'.$modname.'/admin/'.$modpage.'.php');
						if (is_file($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate))
						include($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate);
					}
					//else _ISI_NOTFOUND();
				}
				else { //user area when user is admin but not logged
					if (is_file($inetd["modpath"].'/'.$modname.'/user/'.$modpage.'.php')) {
						require($inetd["modpath"].'/'.$modname.'/user/'.$modpage.'.php');
						if (is_file($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate))
						include($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate);
					} else $userarea_notpresent = true;
				}
			}
			else { //user area when user is not an admin
				if (is_file($inetd["modpath"].'/'.$modname.'/user/'.$modpage.'.php')) {
					require($inetd["modpath"].'/'.$modname.'/user/'.$modpage.'.php');
					if (is_file($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate))
					include($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate);
				} else $userarea_notpresent = true;
			}
		}

	}
	if (($side < 2) && ($id_user == 'Guest' || $userarea_notpresent)) { //public side (performed even if there's no user side)
		if ($modpage != null) {
			if (is_file($inetd["modpath"].'/'.$modname.'/public/'.$modpage.'.php')) {
				require($inetd["modpath"].'/'.$modname.'/public/'.$modpage.'.php');
				if (is_file($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate))
				include($inetd["modpath"].'/'.$modname.'/template/'.$localtemplate);
			}
			//else if (!$isadmin) _ISI_NOTFOUND();
		}
	}
	#
	# print called module html if no template was defined
	//if (!isset($template)) for ($i=0;$i<count($html);$i++)	if (isset($html[$i])) print($html[$i]);
	# empty module html
	$html = array();
	unset($html);
	#
}

?>