<?php
/**
 * user administrator page
 *
 * @package User.administrator
 * @author rio
 * @version 0.0.1
 * @copyright Copyright (C) Sergio Rizzi
 */
class useradministrator {
	/**
	 * @var int class version
	 */
	public $version = '0.0.1';

	/**
	 * constructor
	 */
	function useradministrator() {
		global $userlib, $user, $user_txt, $inetd;
		// POSTs
		if ($_POST[$user["action"]] != null) {
		
			// modifica utente root
			if ($_POST[$user["action"]] == $user["actions"][2]) {
				if ($_POST["pwd"] != $_POST["password2"])
					$this->user_root_modifyroot($user_txt['root_msg_passwordmismatch']);
				else {					
					$array = $userlib->user_modify("1", null, $_POST["pwd"], $_POST["email"], null, null, null, true);
					if ($array != null && $array[0] == false) {
						$this->user_root_modifyroot($array[1]);
					}
					else {
						$this->user_root_modifyroot($user_txt['root_msg_userupdated']);
					}
				}
			}
		
			// modifica utente
			elseif ($_POST[$user["action"]] == $user["actions"][6]) {
				if ($_POST["ID"] != null) {
					$reload = true; $edituser = null;
					if ($edituser[0] == true) $this->user_root_edituser($_POST["ID"], $edituser[1]);
					if ($reload) {
						if (trim($_POST["pwd"]) != '') $pass = $_POST["pwd"];
						else $pass = null;
						$modifyuser = $userlib->user_modify($_POST["ID"], null, $pass, $_POST["email"], $_POST["group"], null, null, true);
						if ($modifyuser[0] == false) {
							print('<h1 style="text-align: center;">'.$user_txt['root_msg_usermodifyerrors'].'</h1>');
							print('<p style="text-align: center; text-weight: bold; color: red;">'.$modifyuser[1].'</p>');
						}
						else {
							print('<h1 style="text-align: center;">'.$user_txt['root_msg_usermodifysuccess'].'</h1>');
						}
						print('<p style="text-align: center; text-weight: bold;">'.$user_txt['root_msg_usermodifysuccess_redirect1'].'<br />'.$user_txt['root_msg_redirect_click'].' <a href="index.php?page=User&'.$user["action"].'='.$user["actions"][5].'&amp;ID='.$_POST["ID"].'">'.$user_txt['root_msg_redirect_here'].'</a> '.$user_txt['root_msg_usermodifysuccess_redirect2'].'</a></p>');
						_ISI_RELOAD($inetd["GETpage"].'=User&'.$user["action"].'='.$user["actions"][5].'&ID='.$_POST["ID"], "30");
						//user_root_edituser($_POST["ID"]);
					}
				}
				else print('<h3 style="text-align: center;">'.$user_txt['root_msg_usernotfound'].'</h3>');
			}
		
			// crea utente
			elseif ($_POST[$user["action"]] == $user["actions"][4]) {
				$enableuser = true;
				$errors = _ISI_CREATEUSER($_POST["username"], $_POST["pwd"], $_POST["email"], $_POST["group"], _ISI_GROUPID_FROMNAME($_POST["groups"]), $enableuser);
				if ($errors[0][1] == false) {
					$this->user_root_create($errors[0][2]);
				}
				else {
					$rdmpassword = $errors[0][2];
					$password = $_POST["pwd"];
					print('<h1 style="text-align: center;">'.$user_txt['root_msg_newusersuccess'].'</h1>');
					if ($password == null || !isset($password) || trim($password) == '') {
						print('<h3 style="text-align: center; text-weight: bold;">'.$user_txt['root_msg_passgenerated'].' '.$rdmpassword.'</h3>');
					}
					print('<p style="text-align: center; text-weight: bold;">'.$user_txt['root_msg_redirect_click'].' <a href="index.php?page=User&'.$user["action"].'='.$user["actions"][4].'">'.$user_txt['root_msg_redirect_here'].'</a> '.$user_txt['root_msg_createduser_redirect1'].'</a></p>');
				}
			}
		}
		
		// GETs
		else {
		
			// modifica utente root
			if ($_GET[$user["action"]] == $user["actions"][1] ||
				$_GET[$user["action"]] == null) $this->user_root_modifyroot();
				
			// gestisce utenti
			elseif ($_GET[$user["action"]] == $user["actions"][3]) $this->user_root_manageusers();
		
			// cancella utente
			elseif ($_GET[$user["action"]] == $user["actions"][7]) {
				if ($_GET["ID"] != null && $_GET["ID"] != 1) {
					$errors = _ISI_SIGNOUT($_GET["ID"]);
					$error = false;
					for ($i = 0; $i < count($errors); $i++) {
						if ($errors[$i][1] == false) {
							$error = true;
							$this->user_root_manageusers($errors[$i][2]);
							$i = count($errors);
						}
					}
					if (!$error) _ISI_RELOAD($inetd["GETpage"].'=User&'.$user["action"].'='.$user["actions"][3]);
				}
				else print('<h3 style="text-align: center;">'.$user_txt['root_msg_usernotfound'].'</h3>');
			}
		
			// visualizza utente
			elseif ($_GET[$user["action"]] == $user["actions"][5]) {
				if ($_GET["ID"] != null) $this->user_root_edituser($_GET["ID"]);
				else print('<h3 style="text-align: center;">'.$user_txt['root_msg_usernotfound'].'</h3>');
			}
		
			// crea utente
			elseif ($_GET[$user["action"]] == $user["actions"][4]) {
				$this->user_root_create();
			}
		
			// aggiungi un utente ad un gruppo
			elseif ($_GET[$user["action"]] == $user["actions"][8]) {
				$userlib->user_group_add($_GET["ID"], $_GET["GROUP"]);
				_ISI_RELOAD($inetd["GETpage"].'=User&'.$user["action"].'='.$user["actions"][5].'&ID='.$_GET["ID"]);
			}
		
			// elimina un utente da un gruppo
			elseif ($_GET[$user["action"]] == $user["actions"][9]) {
				$userlib->user_group_remove($_GET["ID"], $_GET["GROUP"]);
				_ISI_RELOAD($inetd["GETpage"].'=User&'.$user["action"].'='.$user["actions"][5].'&ID='.$_GET["ID"]);
			}
			
		}
	}

	/***** FUNCTIONS *****/

	public function user_root_manageusers ($errormsg = null) {
		global $user_txt;
		print ('<h1 style="text-align: center;">'.$user_txt['root_users_list_title'].'</h1>');
	
		if ($errormsg != null) print('<h3 align="center">'.$user_txt['root_users_msg_warning'].': '.$errormsg.'</h3>');
	
		print('<div style="margin: auto; width: 90%;"><table style="border: 1px solid black; width: 100%; border-collapse: collapse;">');
		print('<tr>');
		print('<td style="border: 1px solid black;"><b>ID</b></td>');
		print('<td style="border: 1px solid black;"><b>'.$user_txt['root_users_username'].'</b></td>');
		print('<td style="border: 1px solid black;"><b>'.$user_txt['root_users_usermail'].'</b></td>');
		print('<td style="border: 1px solid black;"><b>'.$user_txt['root_users_usergroup'].'</b></td>');
		print('<td style="border: 1px solid black;"><b>'.$user_txt['root_users_usergroups'].'</b></td>');
		print('<td style="border: 1px solid black;"><b>&nbsp;</b></td>');
		print('</tr>');
		$this->printlist_users();
		print('</table></div>');
	}
	
	public function printlist_users($type = null) {
		global $userlib, $id_user, $user, $user_txt;
		$userslist = $userlib->users_get();
		for ($i = 0; $i < count($userslist); $i++) {
			$id = $userslist[$i]["ID_MEMBER"];
			$pass = $userslist[$i]["passwd"];
			$start=""; $end="";
			if ($pass == '') { $start="<s>"; $end="</s>"; }
			if ($id != 1) {
				print('<tr>');
				print('<td style="border: 1px solid black;">'.$start.$id.$end.'</td>');
				print('<td style="border: 1px solid black;">'.$start.'<a href="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][5].'&amp;ID='.$id.'">'.$userslist[$i]["memberName"].'</a>'.$end.'</td>');
				print('<td style="border: 1px solid black;">'.$start.'<a href="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][5].'&amp;ID='.$id.'">'.$userslist[$i]["emailAddress"].'</a>'.$end.'</td>');
				print('<td style="border: 1px solid black;">'.$start.'<a href="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][5].'&amp;ID='.$id.'">'._ISI_USERMAINGROUP($id).'</a>'.$end.'</td>');
				print('<td style="border: 1px solid black;">');
				$usergroups = _ISI_INITUSERGROUPS($id);
				if ($usergroups != null) {
					print('<select name="group" style="width: 100%;">');
					for ($n = 0; $n < count($usergroups); $n++) {
						$showgroup = true;
						for ($j = 0; $j < count($user["hiddengroups"]); $j++) {
							if ($usergroups[$n] == $user["hiddengroups"][$j]) {
								$showgroup = false;
							}
						}
						if ($showgroup)
							print('<option>'.$usergroups[$n].'</option>');
					}
					print('</select>');
				}
				print('</td>');
				if ($pass != '')
					print('<td style="border: 1px solid black; width: 10px;"><a href="javascript:void(0);" onClick="
						if (confirm(\''.$user_txt['root_users_delete_question'].'\')) {
							document.location.href=\'index.php?page=User&amp;'.$user["action"].'='.$user["actions"][7].'&amp;ID='.$id.'\';
						} else {
							return false; }" >
						<img src="images/isicms/icons/drop.gif" border="0" /></a></td>');
				else
					print('<td style="border: 1px solid black; width: 10px;">&nbsp;</td>');
				print('</tr>');
			}
		}
	}
	
	
	public function user_root_create($errormsg = null) {
		global $id_user, $user, $groups, $user_txt;
		print ('<h1 style="text-align: center;">'.$user_txt['root_users_createnew'].'</h1>');
	
	
		if ($errormsg != null) print('<h3 align="center">'.$user_txt['root_users_msg_warning'] .': '.$errormsg.'</h3>');
	
		print('
		<table style="width: 100%">
	
		<form method="post" action="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][4].'" name="'.$user["actions"][4].'">
	
		<input type="hidden" name="'.$user["action"].'" value="'.$user["actions"][4].'" />
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_users_username_ask'].':&nbsp;</span></td>
		<td><input name="username" type="text" size="50" style="width: 70%;" value="" maxlength="20" />
		</tr>
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_users_password_ask'].':&nbsp;</span></td>
		<td><input name="pwd" type="password" size="50" style="width: 70%;" value="" />
		</tr>
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_users_email_ask'].':&nbsp;</span></td>
		<td><input name="email" type="text" size="50" style="width: 70%;" value="" />
		</tr>
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_users_group_ask'].':&nbsp;</span></td>
		<td><select name="group" style="width: 70%;">');
		//TODO: FARE QUERY PER SAPERE TUTTI I MAINGROUP
		print('<option value="1">ISIcms</option>');
		print('
		</select>
		</td>
		</tr>
		
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_users_groups_ask'].':&nbsp;</span></td>
		<td><table cellspacing="0" cellpadding="0" style="width: 71%;">
		');
		for ($i = 0; $i < count($groups); $i++) {
			$n = $i+1;
			$groupname = $groups[$i]["name"];
			$showgroup = true;
			for ($j = 0; $j < count($user["hiddengroups"]); $j++) {
				if ($groupname == $user["hiddengroups"][$j]) {
					$showgroup = false;
				}
			}
			if ($showgroup) {
				$groupdescr = $groups[$i]["descr"];
				if ($i == (count($groups) - 1))
					$border = " border-bottom: 1px solid black; ";
				if ($i != 0) {
					print('<tr>');
					print('<td style="border-top: 1px solid black;
						border-left: 1px solid black;'.$border.'">&nbsp;'.$groupname.'</td>');
					print('<td style="border-top: 1px solid black;'.$border.'
						">- '.$groupdescr.'</td>');
					print('<td style="border-top: 1px solid black;
						border-right: 1px solid black; width: 20px; padding-top: 4px;'.$border.'">
					<input type="radio" name="groups" value="'.$groupname.'"></input>
					</td>');
					print('</tr>');
				}
			}
		}
		print('
		</table>
		</td>
		</tr>
		
		<tr>
		<td colspan="2"><hr style="width: 80%;"></td>
		</tr>');
	
		print('
		<tr><td colspan="2">
			<table style="border: 0px solid black; width: 100%;"><tr>
			<td style="width: 50%; text-align: center;">
				<input type="reset" value="'.$user_txt['root_button_reset'].'" /></td>
			<td style="width: 50%; text-align: center;">
				<input type="submit" value="'.$user_txt['root_button_create'].'" /></td>
			</tr></table>
		</td>
		</tr>
	
		</form>
	
		</table>');
	}
	
	
	
	public function user_root_modifyroot($errormsg = null) {
		global $userlib, $id_user, $user, $user_txt;
		$userslist = $userlib->user_show(1);
		print ('<h1 style="text-align: center;">'.$user_txt['root_home_title'].'</h1>');
		print ('<h3 style="text-align: center;">'.$user_txt['root_home_modify'].'</h3>');
	
		if ($errormsg != null) print('<h3 align="center">'.$user_txt['root_users_msg_warning'].': '.$errormsg.'</h3>');
	
		print('
		<table style="width: 100%">
	
		<form method="post" action="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][2].'" name="'.$user["actions"][2].'">
		<input type="hidden" name="'.$user["action"].'" value="'.$user["actions"][2].'" />
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_home_modify_password1'].':&nbsp;</span></td>
		<td><input name="pwd" type="password" size="50" style="width: 70%;" value="" />
		</tr>
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_home_modify_password2'].':&nbsp;</span></td>
		<td><input name="password2" type="password" size="50" style="width: 70%;" value="" />
		</tr>
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_home_modify_mail'].':&nbsp;</span></td>
		<td><input name="email" type="text" size="50" style="width: 70%;" value="'.$userslist[0]["emailAddress"].'" />
		</tr>
	
		<tr>
		<td colspan="2"><hr style="width: 80%;"></td>
		</tr>');
	
		print('
		<tr><td colspan="2">
			<table style="border: 0px solid black; width: 100%;"><tr>
			<td style="width: 50%; text-align: center;">
				<input type="reset" value="'.$user_txt['root_button_reset'].'" /></td>
			<td style="width: 50%; text-align: center;">
				<input type="submit" value="'.$user_txt['root_button_modify'].'" /></td>
			</tr></table>
		</td>
		</tr>
	
		</form>
	
		</table>');
	
	}

	/*
	 * FARE QUERY PER VEDERE A QUALI GRUPPI APPARTIENE UN UTENTE
	 */
	public function printlist_groups($id) {
		global $groups, $user, $user_txt, $userinfo;
		for ($i = 0; $i < count($groups); $i++) {
			$showgroup = true;
			for ($j = 0; $j < count($user["hiddengroups"]); $j++) {
				if ($groups[$i]["name"] == $user["hiddengroups"][$j]) {
					$showgroup = false;
				}
			}
			if ($showgroup) {
				$n = $groups[$i]["gid"];
				$groupname = $groups[$i]["name"];
				$groupdescr = $groups[$i]["descr"];
				$start=""; $end=""; $ingroup = false;
				if (_ISI_ISINGROUP($groupname, $id)) {
					$ingroup = true;
				}
				if ($ingroup) { $start="<b>"; $end="</b>"; }
				if ($i != 0) {
					print('<tr>');
					print('<td style="border: 1px solid black;">'.$start.' '.$groupname.' '.$end.'</td>');
					print('<td style="border: 1px solid black;">'.$start.' '.$groupdescr.' '.$end.'</td>');
					if ($ingroup)
						print('<td style="border: 1px solid black; width: 10px;"><a 
							href="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][9].'&amp;ID='.$id.'&amp;GROUP='.$n.'"><img
							src="images/isicms/icons/drop.gif" border="0" /></a></td>');
		/*
						print('<td style="border: 1px solid black; width: 10px;"><a href="javascript:void(0);" onClick="
							if (confirm(\''.$user_txt['root_users_delfromgroup_question'].'\')) {
								document.location.href=\'index.php?page=User&amp;'.$user["action"].'='.$user["actions"][9].'&amp;ID='.$id.'&amp;GROUP='.$n.'\';
							} else {
								return false; }" >
							<img src="images/isicms/icons/drop.gif" border="0" /></a></td>');
		*/
					else
						print('<td style="border: 1px solid black; width: 10px;"><a 
							href="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][8].'&amp;ID='.$id.'&amp;GROUP='.$n.'"><img
							src="images/isicms/icons/enable.gif" border="0" /></a></td>');
					
		/*
						print('<td style="border: 1px solid black; width: 10px;"><a href="javascript:void(0);" onClick="
							if (confirm(\''.$user_txt['root_users_addtogroup_question'].'\')) {
								document.location.href=\'index.php?page=User&amp;'.$user["action"].'='.$user["actions"][8].'&amp;ID='.$id.'&amp;GROUP='.$n.'\';
							} else {
								return false; }" >
							<img src="images/isicms/icons/enable.gif" border="0" /></a></td>');
		*/
					print('</tr>');
				}
			}
		}
	}
	
	
	public function user_root_edituser ($id, $error = null) {
		global $userlib, $id_user, $user, $user_txt;
		$userslist = $userlib->user_show($id);
		$pass = $userslist[0]["passwd"];
		print ('<h1 style="text-align: center;">'.$user_txt['root_auser_title'].' '.$userslist[0]["memberName"].'</h1>');
		
		if ($error != null) print ('<h3 style="text-align: center;">'.$error.'</h3>');
		if ($pass == '') print('<h3 style="text-align: center;">'.$user_txt['root_auser_reenable1'].'<br />'.$user_txt['root_auser_reenable2'].'</h3>');
	
	
		print('
		<table style="width: 100%">
	
		<form method="post" action="index.php?page=User&amp;'.$user["action"].'='.$user["actions"][6].'" name="'.$user["actions"][6].'">
	
		<input type="hidden" name="'.$user["action"].'" value="'.$user["actions"][6].'" />
		<input type="hidden" name="ID" value="'.$id.'" />
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_home_modify_password1'].':&nbsp;</span></td>
		<td><input name="pwd" type="password" size="50" style="width: 70%;" value="" />
		</tr>
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_home_modify_mail'].':&nbsp;</span></td>
		<td><input name="email" type="text" size="50" style="width: 70%;" value="'.$userslist[0]["emailAddress"].'" />
		</tr>
	
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_auser_modify_group'].':&nbsp;</span></td>
		<td><select name="group" style="width: 70%;">');
		//TODO: FARE QUERY PER SAPERE TUTTI I MAINGROUP
		print('<option value="1">ISIcms</option>');
		print('
		</select>
		</td>
		</tr>
		
		<tr>
		<td style="width: 30%; text-align: right;"><span>'.$user_txt['root_auser_modify_groups'].':&nbsp;</span></td>
		<td><table name="group" style="width: 70%;">');
		$this->printlist_groups($id);
		print('</table>
		</td>
		</tr>
	
		<tr>
		<td colspan="2"><hr style="width: 80%;"></td>
		</tr>');
	
		print('
		<tr><td colspan="2">
			<table style="border: 0px solid black; width: 100%;"><tr>
			<td style="width: 50%; text-align: center;">
				<input type="reset" value="'.$user_txt['root_button_reset'].'" /></td>
			<td style="width: 50%; text-align: center;">
				<input type="submit" value="'.$user_txt['root_button_modify'].'" /></td>
			</tr></table>
		</td>
		</tr>
	
		</form>
	
		</table>');
	}
	
}
?>
