<?php

new userlicense();

/**
 * user license agreement page
 *
 * @package User.license
 * @author rio
 * @version 0.0.1
 * @copyright Copyright (C) Sergio Rizzi
 */
class userlicense {
	/**
	 * @var int class version
	 */
	public $version = '0.0.1';

	/**
	 * @var string license files
	 */
	public $licenseFiles = array(
			0 =>
			array (
				0 => 'Core System',
				1 => 'modules/inetd/licenses/LICENSE-gpl.txt'),

			1 =>
			array (
				0 => 'Moduli',
				1 => 'modules/inetd/licenses/LICENSE-eula.txt'),
			);	

	/**
	 * constructor
	 */
	function userlicense() {
		global $userlib, $user, $user_txt;
		
		if ($_GET[$user["license_action"]] == $user_txt['license_accept']) {
			$userlib->userAcceptLicense();
			_ISI_RELOAD('page=User');
		}	
			
		elseif ($_GET[$user["license_action"]] == $user_txt['license_refuse']) {
			_ISI_RELOAD('auth=false');
		}
		
		else $this->print_license();
	}

	/***** FUNCTIONS *****/

	public function print_license ($msg = null) {
		global $user, $user_txt;
		$licenses = $this->licenseFiles;
		for ($i=0; $i<count($licenses); $i++) {
			$moduleName = $licenses[$i][0];
			$licenseContent = @file_get_contents($licenses[$i][1]);
			print('
<h1 style="text-align: center;">Licenza '.$moduleName.'</h1>
<div style="overflow: auto; height: 200px; border: 1px dotted black;">
	<pre>');
			echo $licenseContent;
			print('
	</pre>
</div>
<br /><br />
			');
		}
		print ('
			<form action="index.php">
			<table style="width: 100%"><tr>
			<td style="text-align: center">
				<input id="button" type="submit" value="'.$user_txt['license_refuse'].'" name="'.$user["license_action"].'">
			</td>
			<td style="text-align: center"> 
				<input id="button" type="submit" value="'.$user_txt['license_accept'].'" name="'.$user["license_action"].'">
			</td>
			</tr></table>
			</form>
		');
	}
}
?>
