<?php
# power on cms
# boot ($db_conn -> db connection)
require_once ('modules/inetd/boot.php'); _ISI_DBCONN();

# maintenance management
if ($maintenaince) {
	include('include/common/maintenaince.html');
	exit(0);
}

# be sure to reset debug vars
$inetd["admin"]["print_modname"] = 0;
$inetd["admin"]["print_pass"] = 0;
$inetd["debug"] = false;

# loads database and layout specific configurations
_ISI_POSTCONF();
# session manager (inetd.lib.php)
_ISI_SESSION();
# locale manager
_ISI_LOCALE();
# template manager
_ISI_TEMPLATE();
# rss header (coded down here)
_ISI_RSSHEAD();
# rss body (coded down here)
 _ISI_RSSBODY();
# rss footer (coded down here)
_ISI_RSSFOOT();

function _ISI_RSSHEAD() {
	global $inetd, $locale;
 print('<?php xml version="1.0" encoding="utf8" ?>

<rss version="2.0">
	<channel>
		<title>'.$inetd["headtitle"].'</title>
		<link>'.$inetd["url"].'/</link>
		<description>'.$inetd["rss_descr"].'</description>
		<copyright>Copyright '.date("Y").' - isigame.net</copyright>
		<lastBuildDate>'.date("D, j M Y H:m:s O").'</lastBuildDate>
		<generator>'.$inetd["url"].'/</generator>
		<docs>http://blogs.law.harvard.edu/tech/rss</docs>
		<managingEditor>'.$inetd["webmaster_mail"].'</managingEditor>
		<webMaster>'.$inetd["webmaster_mail"].'</webMaster>
		<users-online>');
 # visits counter module -> print online users
 inetd('Webstats','counter');
 inetd('Webstats','onlineusers');
 print('</users-online>');

 if ($_GET["type"] == "0" || $_GET["type"] == null)
 print('
 		<item>
 			<title>'.$inetd["rss"][0].'</title>
			<description><![CDATA['.$inetd["rss"][0].']]></description>
			<link>'.$inetd["url"].'/</link>
			<guid>'.$inetd["url"].'/</guid>
			<category>News</category>
			<pubDate>'.date("D, j M Y H:m:s O").'</pubDate>
		</item>');

 if ($_GET["type"] == "1") print('
 		<item>
 			<title>'.$inetd["rss"][1].'</title>
			<description><![CDATA['.$inetd["rss"][1].']]></description>
			<link>'.$inetd["url"].'/'.$inetd["forumpath"].'</link>
			<guid>'.$inetd["url"].'/'.$inetd["forumpath"].'</guid>
			<category>Forum</category>
			<pubDate>'.date("D, j M Y h:m:s O").'</pubDate>
		</item>');
}

function _ISI_RSSBODY() {
	global $inetd, $locale;
	echo '
		<item>
			<title>ISIcms</title>
			<description><![CDATA[ISIcms]]></description>
			<link>'.$inetd["url"].'</link>
			<category>ISIcms</category>
			<pubDate>'.date("D, j M Y H:m:s O").'</pubDate>
		</item>';
		}
	}
}

function _ISI_RSSFOOT() {
	echo '
	</channel>
</rss>';
}
?>
